#ifndef _COLOR_WINDOW_H_
#define _COLOR_WINDOW_H_

#include <Window.h>
#include <View.h>
#include <Button.h>
#include <iostream>
#include <Messenger.h>
#include <StringView.h>
#include <ScrollView.h>
#include <Font.h>
#include <ColorControl.h>
#include <TypeConstants.h>
#include "Constants.h"
#include "color_view.h"

class FastColor : public BColorControl
{
	public:
		FastColor(colorView* theWell,BPoint leftTop,color_control_layout matrix,float cellSide,
		const char* name,BMessage* message = NULL,bool bufferedDrawing = false);
		void SetValue(int32 v);
		void SetValue(rgb_color c);
	 private:
	 colorView* well;
};

class ColorWindow : public BWindow
{
	public:
		ColorWindow(BRect r,BMessenger* messenger,rgb_color c);
		~ColorWindow();
		virtual void MessageReceived(BMessage* msg);
		void Quit();
	private:
		BMessenger* msgr;
		BButton* fOk;
		BButton* fCancel;	//default btn
		BView* parent;
		FastColor* ctrlbox;
		colorView* cv;
};


#endif

