#ifndef _CHAR_RENDERER_H_
#define _CHAR_RENDERER_H_

#include <ft2build.h>
#include FT_FREETYPE_H
#include FT_INTERNAL_TYPE1_TYPES_H
#include <freetype2/freetype/ftglyph.h>

#include <iostream>
#include <Bitmap.h>
#include <Path.h>
class CharRenderer
{
	public:
		CharRenderer();
		void SetSize(int s);
		void SetPath(const char* p);
		void SetColor(rgb_color c);
		void SetAngle(float angle);
		BBitmap* Render(int idx);
		//BBitmap* RenderColored(int idx,rgb_color c);
	private:
		status_t error;
		FT_Library lib;
		FT_Face face;
		FT_Glyph glyph;
		FT_BitmapGlyph bitmap;
		
		BPath path;		//full path of the font
		int size;			//size of font in pixels
		rgb_color color;	//color of rendered text
		
		
		int width;
		int height;
		int bpr;	//bytes per row of final
		int pitch;
		
		rgb_color* color_ptr;
		int alpha;
		BBitmap* final;
		
		float theta;
};
#endif