#include "PrefsWindow.h"
BitmapView::BitmapView(BRect r,BBitmap* b) : BView(r,"bitmapview",B_FOLLOW_NONE,B_WILL_DRAW)
{
	SetViewColor(ui_color(B_PANEL_BACKGROUND_COLOR));
	bitmap = b;
}
void BitmapView::Draw(BRect r)
{
	SetDrawingMode(B_OP_ALPHA);
	DrawBitmap(bitmap);
}
PrefsWindow::PrefsWindow(BRect r,BMessenger* messenger,Prefs* p) : BWindow(r,"Preferences",B_FLOATING_WINDOW,B_NOT_ZOOMABLE|B_NOT_RESIZABLE|B_NOT_CLOSABLE|B_ASYNCHRONOUS_CONTROLS)
{
	SetFeel(B_NORMAL_WINDOW_FEEL);
	prefs = p;
	backup_prefs = *p;
	
	parent = new BView(Bounds(),"parent",B_FOLLOW_ALL_SIDES,B_WILL_DRAW);
	parent->SetViewColor(ui_color(B_PANEL_BACKGROUND_COLOR));
	AddChild(parent);
	
	msgr = messenger;

	r = Bounds();
	
	BFont font(be_fixed_font);
	font.SetSize(prefs->FontSize);
	
	
	int PLV_WIDTH = 80;
	int  RESPITE_WIDTH = 41;
	int bwidth=80;
	int bheight=30;
	int bspacing=10;
	
	
	
	plv = new PrefsListView(BRect(10,10,10+PLV_WIDTH,r.bottom-10),parent);
	BScrollView* sv = new BScrollView("ScrollView",plv,B_FOLLOW_LEFT | B_FOLLOW_TOP,B_WILL_DRAW,false,false);
	parent->AddChild(sv);
	
	BRect BBOX_RECT(10+PLV_WIDTH+10,2,r.right-7,r.bottom-10-RESPITE_WIDTH);
	
/*	BBox* general_box = new BBox(BBOX_RECT);
	general_box->SetLabel("General");
	plv->AddItem(new PrefsListItem(general_box,parent,"General"));
*/	
	BBox* color_box = new BBox(BBOX_RECT);
	color_box->SetLabel("TexView");

	int offset = 30;
	int tvwidth=280;
	int tvheight=200;
	//BRect cbbtnRect(cbRect.right-bspacing-bwidth,cbRect.bottom-bspacing-bheight,cbRect.right-bspacing,cbRect.bottom-bspacing);
	r = color_box->Bounds();
	int adjust=5;
	BRect tvRect(r.right-tvwidth-(offset*2/3),offset-adjust,r.right-(offset*2/3)-B_V_SCROLL_BAR_WIDTH,offset+tvheight-adjust);	
	BRect tvTextRect(tvRect);
	//tvTextRect.InsetBy(offset,offset);
	
	tv = new TexView(tvRect,tvTextRect,prefs);
	BString sample_text = "Welcome to \\betex!\\\\\n%This is a Comment\n$Phe\\alpha r the Calculus$\n\\subsection{About \\betex}\n\\betex is \\textbf{cool}!\\\\\n``To Be Or Not To Be\'\'\n";
	tv->SetText(sample_text.String(),sample_text.Length());
	//findview->MakeFocus(true);
	//sv->SetNormalFocus();
	//tv->SetStylable(true);
	tv->MakeEditable(false);
	tv->MakeSelectable(false);
	//findview->SetAttachedFocus();
	//findview->SetFlags(B_NAVIGABLE|replaceview->Flags());
	sv = new BScrollView("ScrollView",tv,B_FOLLOW_LEFT | B_FOLLOW_TOP,
	B_WILL_DRAW|B_FRAME_EVENTS|B_NAVIGABLE,false,true,B_FANCY_BORDER);
	sv->SetViewColor(ui_color(B_PANEL_BACKGROUND_COLOR));
	color_box->AddChild(sv);
	tv->SetTextRect(tv->Bounds());
	int cbheight=14;
	int cbspacing = 10;
//	BRect tvRect(offset/2,offset,offset+tvwidth,offset/2+tvheight);	

	BRect ccRect((offset*2/3),offset-adjust,offset+150,offset+cbheight-adjust);
	//tvRect.right + 20,tvRect.top-2,tvRect.right + 20 + 150,tvRect.top-2+cbheight);
	fg_color_button      = new ColorButton(ccRect,new BMessage(PREFS_VIEW_FG_UPDATE),prefs->fg_color,"Text");
	ccRect.OffsetBy(0,cbheight+cbspacing);
	bg_color_button      = new ColorButton(ccRect,new BMessage(PREFS_VIEW_BG_UPDATE),prefs->bg_color,"Background");
	ccRect.OffsetBy(0,cbheight+cbspacing);
	generic_cmd_color_button = new ColorButton(ccRect,new BMessage(PREFS_VIEW_GEN_UPDATE),prefs->generic_cmd_color,"Generic Commands");
	ccRect.OffsetBy(0,cbheight+cbspacing);
	format_cmd_color_button  = new ColorButton(ccRect,new BMessage(PREFS_VIEW_FORM_UPDATE),prefs->format_cmd_color,"Formatting Commands");
	ccRect.OffsetBy(0,cbheight+cbspacing);
	special_cmd_color_button = new ColorButton(ccRect,new BMessage(PREFS_VIEW_SPEC_UPDATE),prefs->special_cmd_color,"Special Commands");
	ccRect.OffsetBy(0,cbheight+cbspacing);
	math_mode_color_button   = new ColorButton(ccRect,new BMessage(PREFS_VIEW_MATH_UPDATE),prefs->math_mode_color,"Math Mode");
	ccRect.OffsetBy(0,cbheight+cbspacing);
	comma_color_button           = new ColorButton(ccRect,new BMessage(PREFS_VIEW_COMA_UPDATE),prefs->comma_color,"Quotation Marks");
	ccRect.OffsetBy(0,cbheight+cbspacing);
	comment_color_button     = new ColorButton(ccRect,new BMessage(PREFS_VIEW_COMT_UPDATE),prefs->comment_color,"Comments");
	ccRect.OffsetBy(0,cbheight+cbspacing);
	punc_symbol_color_button = new ColorButton(ccRect,new BMessage(PREFS_VIEW_PUNC_UPDATE),prefs->punc_symbol_color,"Punctuation / Symbols");
	ccRect.OffsetBy(0,cbheight+cbspacing);
	//html_color_button = new ColorButton(ccRect,new BMessage(PREFS_VIEW_HTML_UPDATE),prefs->html_color,"Urls");

	color_box->AddChild(fg_color_button);
	color_box->AddChild(bg_color_button);
	color_box->AddChild(generic_cmd_color_button);
	color_box->AddChild(format_cmd_color_button);
	color_box->AddChild(special_cmd_color_button);
	color_box->AddChild(math_mode_color_button);
	color_box->AddChild(comma_color_button);
	color_box->AddChild(comment_color_button);
	color_box->AddChild(punc_symbol_color_button);
	//color_box->AddChild(html_color_button);
	
	BRect cbRect = color_box->Bounds();
	BRect cbbtnRect(cbRect.right-bspacing-bwidth,cbRect.bottom-bspacing-bheight,cbRect.right-bspacing,cbRect.bottom-bspacing);
	fResetColorDefaults = new BButton(cbbtnRect,"fResetColorDefaults","Defaults",new BMessage(PREFS_VIEW_RESET_COLOR_DEFAULTS));
	color_box->AddChild(fResetColorDefaults);
	
	int minVal=5;
	int maxVal=30;
	int slider_width=300;
	int vert_offset = 50;
	fontsizeSlider = new BSlider(BRect(ccRect.left,ccRect.top+vert_offset,ccRect.left+slider_width,ccRect.top+vert_offset+100),
	"fontsizeslider","Font Size",new BMessage(PREFS_VIEW_FONTSIZE_UPDATE),minVal,maxVal);//,B_TRIANGLE_THUMB);
	
	fontsizeSlider->SetBarColor(ui_color(B_WINDOW_TAB_COLOR));
	fontsizeSlider->SetHashMarks(B_HASH_MARKS_BOTTOM);
	fontsizeSlider->SetHashMarkCount(26);
	fontsizeSlider->SetValue(prefs->FontSize/2);
	fontsizeSlider->SetLimitLabels("Small","Large");
	fontsizeSlider->SetModificationMessage(new BMessage(PREFS_VIEW_FONTSIZE_UPDATE));
	
	
	rgb_color fire_r = {223,0,50};
	const rgb_color* fillcolor = &fire_r;
	fontsizeSlider->UseFillColor(true,fillcolor);
	
	color_box->AddChild(fontsizeSlider);
	//fontsizeSlider->ResizeToPreferred();
	

	
	
	r = Bounds();
	BRect btnRect(r.right-bspacing-bwidth,r.bottom-bspacing-bheight,r.right-bspacing,r.bottom-bspacing);
	fOk = new BButton(btnRect,"fOk","Ok",new BMessage(PREFS_VIEW_OK));
	parent->AddChild(fOk);
	fOk->MakeDefault(true);
	
/*
	btnRect.OffsetBy(-(bwidth+2*bspacing),0);
	fResetDefaults = new BButton(btnRect,"fResetDefaults","Defaults",new BMessage(PREFS_VIEW_RESET_DEFAULTS));
	parent->AddChild(fResetDefaults);
*/	
	btnRect.OffsetBy(-(bwidth+2*bspacing),0);
	fCancel = new BButton(btnRect,"fCancel","Cancel",new BMessage(PREFS_VIEW_CANCEL));
	parent->AddChild(fCancel);
	
	
	BBox* command_box = new BBox(BBOX_RECT);
	command_box->SetLabel("Commands");
	
	int global_tc_offset=45;
	TextCtrlInfo = new BStringView(BRect(offset/2,offset,offset/2+300,offset+20),
	"info","The \'$\' represents the filename in filename.tex");
	command_box->AddChild(TextCtrlInfo);
	BBitmap* TexDviBitmap = new BBitmap(BRect(0,0,31,31),B_CMAP8);
	TexDviBitmap->SetBits(TexToDVI,3072,0,B_CMAP8);
	
	BBitmap* DviPdfBitmap = new BBitmap(BRect(0,0,31,31),B_CMAP8);
	DviPdfBitmap->SetBits(DVIToPDF,3072,0,B_CMAP8);
	
	BBitmap* DviPsBitmap = new BBitmap(BRect(0,0,31,31),B_CMAP8);
	DviPsBitmap->SetBits(DVIToPS,3072,0,B_CMAP8);
			
	
	BBitmap* PsPdfBitmap = new BBitmap(BRect(0,0,31,31),B_CMAP8);
	PsPdfBitmap->SetBits(PSToPDF,3072,0,B_CMAP8);
				
	BBitmap* TexPdfBitmap = new BBitmap(BRect(0,0,31,31),B_CMAP8);
	TexPdfBitmap->SetBits(TexToPDF,3072,0,B_CMAP8);
				
	BBitmap* TexHtmlBitmap = new BBitmap(BRect(0,0,31,31),B_CMAP8);
	TexHtmlBitmap->SetBits(TexToHTML,3072,0,B_CMAP8);
		
	BBitmap* PostScriptBitmap = new BBitmap(BRect(0,0,31,31),B_CMAP8);
	PostScriptBitmap->SetBits(PrevPS,3072,0,B_CMAP8);
		
	int bitoffset=45;
	BRect bitRect(offset/2,offset+global_tc_offset,offset/2+31,offset+31+global_tc_offset);
	BRect SecCol(bitRect);
	int sec_offset=170;
	SecCol.OffsetBy(sec_offset,0);
	
	command_box->AddChild(new BitmapView(bitRect,TexDviBitmap));
	bitRect.OffsetBy(0,bitoffset);
			
	command_box->AddChild(new BitmapView(bitRect,DviPdfBitmap));
	bitRect.OffsetBy(0,bitoffset);
			
	command_box->AddChild(new BitmapView(bitRect,DviPsBitmap));
	bitRect.OffsetBy(0,bitoffset);
			
	command_box->AddChild(new BitmapView(bitRect,PsPdfBitmap));
	bitRect.OffsetBy(0,bitoffset);
			
	command_box->AddChild(new BitmapView(bitRect,TexPdfBitmap));
	bitRect.OffsetBy(0,bitoffset);
			
	command_box->AddChild(new BitmapView(bitRect,TexHtmlBitmap));
	bitRect.OffsetBy(0,bitoffset);
	
	command_box->AddChild(new BitmapView(SecCol,PostScriptBitmap));
	SecCol.OffsetBy(0,bitoffset);
	
	
	int textctrl_width = 100;
	int textctrl_height = 20;
	int textctrl_co = 6;
	BRect bitctrlRect(offset/2+bitoffset,offset+textctrl_co+global_tc_offset,offset/2+bitoffset+textctrl_width,textctrl_co+offset+textctrl_height+global_tc_offset);		
	BRect SecColCtrl(bitctrlRect);
	SecColCtrl.OffsetBy(sec_offset,0);
	SecColCtrl.right += 50;
	TexDviCtrl = new BTextControl(bitctrlRect,"tc",NULL,prefs->latex_cmd.String(),NULL);
	command_box->AddChild(TexDviCtrl);
	bitctrlRect.OffsetBy(0,bitoffset);
	
	DviPdfCtrl = new BTextControl(bitctrlRect,"tc",NULL,prefs->dvipdf_cmd.String(),NULL);
	command_box->AddChild(DviPdfCtrl);
	bitctrlRect.OffsetBy(0,bitoffset);
	
	DviPsCtrl = new BTextControl(bitctrlRect,"tc",NULL,prefs->dvips_cmd.String(),NULL);
	command_box->AddChild(DviPsCtrl);
	bitctrlRect.OffsetBy(0,bitoffset);
	
	PsPdfCtrl = new BTextControl(bitctrlRect,"tc",NULL,prefs->ps2pdf_cmd.String(),NULL);
	command_box->AddChild(PsPdfCtrl);
	bitctrlRect.OffsetBy(0,bitoffset);
	
	TexPdfCtrl = new BTextControl(bitctrlRect,"tc",NULL,prefs->pdflatex_cmd.String(),NULL);
	command_box->AddChild(TexPdfCtrl);
	bitctrlRect.OffsetBy(0,bitoffset);
	
	TexHtmlCtrl = new BTextControl(bitctrlRect,"tc",NULL,prefs->latex2html_cmd.String(),NULL);
	command_box->AddChild(TexHtmlCtrl);
	bitctrlRect.OffsetBy(0,bitoffset);
	
	PostScriptCtrl = new BTextControl(SecColCtrl,"tc",NULL,prefs->postscript_cmd.String(),NULL);
	command_box->AddChild(PostScriptCtrl);
	SecColCtrl.OffsetBy(0,bitoffset);
	
	
	
	BRect comboxRect = command_box->Bounds();
	BRect comboxbtnRect(comboxRect.right-bspacing-bwidth,comboxRect.bottom-bspacing-bheight,comboxRect.right-bspacing,comboxRect.bottom-bspacing);
	fResetCommandDefaults = new BButton(comboxbtnRect,"fResetCommandDefaults","Defaults",new BMessage(PREFS_VIEW_RESET_COMMAND_DEFAULTS));
	command_box->AddChild(fResetCommandDefaults);

	BBox* toolbar_box = new BBox(BBOX_RECT);
	toolbar_box->SetLabel("Toolbars");
	
	int vert_cb_spacing=25;
	BRect checkbox_rect = BRect((offset*2/3),offset-adjust,(offset*2/3)+150,offset-adjust+vert_cb_spacing-5);
	
	tb_invert_cb = new BCheckBox(checkbox_rect,"tb_invert","Invert Toolbar Colours",new BMessage(PREFS_VIEW_TOOLBAR_INVERT));
	tb_invert_cb->SetValue(prefs->IsTexBarInverted);
	checkbox_rect.OffsetBy(0,vert_cb_spacing);

	tb_GreekHidden_cb = new BCheckBox(checkbox_rect,"tb_GreekHidden_cb","Greek Letters",new BMessage(PREFS_VIEW_TOOLBAR_GREEK));
	tb_GreekHidden_cb->SetValue(!prefs->IsGreekAbsent);
	checkbox_rect.OffsetBy(0,vert_cb_spacing);
	
	tb_BigHidden_cb = new BCheckBox(checkbox_rect,"tb_BigHidden_cb","Big Operators",new BMessage(PREFS_VIEW_TOOLBAR_BIG));
	tb_BigHidden_cb->SetValue(!prefs->IsBigAbsent);
	checkbox_rect.OffsetBy(0,vert_cb_spacing);
	
	tb_BinaryHidden_cb = new BCheckBox(checkbox_rect,"tb_BinaryHidden_cb","Binary Operators",new BMessage(PREFS_VIEW_TOOLBAR_BINARYOP));
	tb_BinaryHidden_cb->SetValue(!prefs->IsBinaryAbsent);
	checkbox_rect.OffsetBy(0,vert_cb_spacing);
	
	tb_MiscHidden_cb = new BCheckBox(checkbox_rect,"tb_MiscHidden_cb","Misc Symbols",new BMessage(PREFS_VIEW_TOOLBAR_MISC));
	tb_MiscHidden_cb->SetValue(!prefs->IsMiscAbsent);
	checkbox_rect.OffsetBy(0,vert_cb_spacing);
	
	tb_BinRelHidden_cb = new BCheckBox(checkbox_rect,"tb_BinRelHidden_cb","Binary Relations",new BMessage(PREFS_VIEW_TOOLBAR_BINARYREL));
	tb_BinRelHidden_cb->SetValue(!prefs->IsBinRelAbsent);
	checkbox_rect.OffsetBy(0,vert_cb_spacing);
	
	tb_MMAHidden_cb = new BCheckBox(checkbox_rect,"tb_MMAHidden_cb","Math Mode Accents",new BMessage(PREFS_VIEW_TOOLBAR_MMA));
	tb_MMAHidden_cb->SetValue(!prefs->IsMMAAbsent);
	checkbox_rect.OffsetBy(0,vert_cb_spacing);
	
	tb_IntlHidden_cb = new BCheckBox(checkbox_rect,"tb_IntlHidden_cb","International",new BMessage(PREFS_VIEW_TOOLBAR_INT));
	tb_IntlHidden_cb->SetValue(!prefs->IsIntlAbsent);
	checkbox_rect.OffsetBy(0,vert_cb_spacing);
	
	tb_TypeFaceHidden_cb = new BCheckBox(checkbox_rect,"tb_TypeFaceHidden_cb","Type Faces",new BMessage(PREFS_VIEW_TOOLBAR_TYPEFACE));
	tb_TypeFaceHidden_cb->SetValue(!prefs->IsTypeFaceAbsent);
	checkbox_rect.OffsetBy(0,vert_cb_spacing);
	
	tb_FunctionHidden_cb = new BCheckBox(checkbox_rect,"tb_FunctionHidden_cb","Functions",new BMessage(PREFS_VIEW_TOOLBAR_FUNCTION));
	tb_FunctionHidden_cb->SetValue(!prefs->IsFunctionAbsent);
	checkbox_rect.OffsetBy(0,vert_cb_spacing);

	toolbar_box->AddChild(tb_invert_cb);
	toolbar_box->AddChild(tb_GreekHidden_cb);
	toolbar_box->AddChild(tb_BigHidden_cb);
	toolbar_box->AddChild(tb_BinaryHidden_cb);
	toolbar_box->AddChild(tb_MiscHidden_cb);
	toolbar_box->AddChild(tb_BinRelHidden_cb);
	toolbar_box->AddChild(tb_MMAHidden_cb);
	toolbar_box->AddChild(tb_IntlHidden_cb);
	toolbar_box->AddChild(tb_TypeFaceHidden_cb);
	toolbar_box->AddChild(tb_FunctionHidden_cb);	

	BRect toolbarRect = toolbar_box->Bounds();
	BRect toolbarbtnRect(toolbarRect.right-bspacing-bwidth,toolbarRect.bottom-bspacing-bheight,toolbarRect.right-bspacing,toolbarRect.bottom-bspacing);
	fResetToolbarDefaults = new BButton(toolbarbtnRect,"fResetToolbarDefaults","Defaults",new BMessage(PREFS_VIEW_RESET_TOOLBAR_DEFAULTS));
	toolbar_box->AddChild(fResetToolbarDefaults);


	BBox* general_box = new BBox(BBOX_RECT);
	general_box->SetLabel("General");
	
	
	ccRect = BRect((offset*2/3),offset-adjust,offset+150,offset+cbheight-adjust);
	//tvRect.right + 20,tvRect.top-2,tvRect.right + 20 + 150,tvRect.top-2+cbheight);
	bubble_color_button = new ColorButton(ccRect,new BMessage(PREFS_VIEW_GENERAL_BUBBLE_UPDATE),prefs->bubble_color,"Tooltips");
	ccRect.OffsetBy(0,cbheight+cbspacing+40);
	ccRect.right = ccRect.left += 200;
	ccRect.bottom = ccRect.top += 50;
	
	
	
	ShowRecentDocsPath_cb = new BCheckBox(BRect((offset*2/3),50,(offset*2/3)+150,70),"ShowRecentDocsPath_cb","Show Path in Recent Docs",
	new BMessage(PREFS_VIEW_GENERAL_SHOW_RDPATH));
	ShowRecentDocsPath_cb->SetValue(prefs->IsRecentDocsPathShown);
	
	IsActivationOk_cb = new BCheckBox(BRect((offset*2/3),80,(offset*2/3)+190,100),"IsActivationOk_cb","Activate Window on Opening Docs",
	new BMessage(PREFS_VIEW_GENERAL_ACTIVATE_WINDOW));
	IsActivationOk_cb->SetValue(prefs->IsActivationOk);
	
	TCNumRecentDocs = new BTextControl(BRect((offset*2/3),110,(offset*2/3)+150,120),"tc","Number of Recent Docs",prefs->NumRecentDocs.String(),NULL);
	TCNumRecentDocs->SetDivider(120);
	TCNumRecentDocs->SetAlignment(B_ALIGN_RIGHT,B_ALIGN_LEFT);
	
	TCInsertDateFlags = new BTextControl(BRect((offset*2/3),140,(offset*2/3)+200,150),"tc2","Insert Date Flags",prefs->dateFlags.String(),NULL);
	//TCInsertDateFlags->SetDivider(120);
	//TCInsertDateFlags->SetAlignment(B_ALIGN_LEFT,B_ALIGN_LEFT);
	
	//checkbox_rect.OffsetBy(0,vert_cb_spacing);
	general_box->AddChild(bubble_color_button);
	general_box->AddChild(ShowRecentDocsPath_cb);
	general_box->AddChild(IsActivationOk_cb);
	general_box->AddChild(TCNumRecentDocs);
	general_box->AddChild(TCInsertDateFlags);
	
	BRect generalRect = general_box->Bounds();
	BRect generalbtnRect(generalRect.right-bspacing-bwidth,generalRect.bottom-bspacing-bheight,generalRect.right-bspacing,generalRect.bottom-bspacing);
	fResetGeneralDefaults = new BButton(generalbtnRect,"fResetGeneralDefaults","Defaults",new BMessage(PREFS_VIEW_RESET_GENERAL_DEFAULTS));
	general_box->AddChild(fResetGeneralDefaults);
	
	plv->AddItem(new PrefsListItem(general_box,parent,"General"));
	plv->AddItem(new PrefsListItem(command_box,parent,"Commands"));
	plv->AddItem(new PrefsListItem(color_box,parent,"TexView"));
	plv->AddItem(new PrefsListItem(toolbar_box,parent,"Toolbars"));
	
	plv->Select(0);
	plv->MakeFocus(true);
}
PrefsWindow::~PrefsWindow()
{
	delete msgr;
}
void PrefsWindow::MessageReceived(BMessage* msg)
{
	switch(msg->what)
	{
		case PREFS_VIEW_RESET_COLOR_DEFAULTS:
		{
			prefs->fg_color = Black;
			prefs->bg_color = White;
			prefs->generic_cmd_color = Red;
			prefs->format_cmd_color = Green;
			prefs->special_cmd_color = Purple;
			prefs->math_mode_color = NavyBlue;
			prefs->comma_color = Red;
			prefs->comment_color = Blue;
			prefs->punc_symbol_color = Purple;
			//prefs->html_color = Orange;
			
			fg_color_button->SetValue(prefs->fg_color);
			bg_color_button->SetValue(prefs->bg_color);
			generic_cmd_color_button->SetValue(prefs->generic_cmd_color);
			format_cmd_color_button->SetValue(prefs->format_cmd_color);
			special_cmd_color_button->SetValue(prefs->special_cmd_color);
			math_mode_color_button->SetValue(prefs->math_mode_color);
			comma_color_button->SetValue(prefs->comma_color);
			comment_color_button->SetValue(prefs->comment_color);
			punc_symbol_color_button->SetValue(prefs->punc_symbol_color);
			//html_color_button->SetValue(prefs->html_color);
			//prefs->ResetToDefaults();
			//tv->UpdateColors();
			
			prefs->FontSize = 12;//fontsizeSlider->Value()*2;
			fontsizeSlider->SetValue(12/2);
			tv->UpdateFontSize();
			tv->SetViewColor(prefs->bg_color);
			tv->Invalidate();
			//prefs->Save();
			//Quit();
		}break;
		case PREFS_VIEW_FONTSIZE_UPDATE:
		{
			//cout << fontsizeSlider->Value()*2 << endl;
			prefs->FontSize = fontsizeSlider->Value()*2;
			tv->UpdateFontSize();
		}break;
		case PREFS_VIEW_RESET_COMMAND_DEFAULTS:
		{
			prefs->latex_cmd = "latex $.tex";
			prefs->dvipdf_cmd = "dvipdf $.dvi";
			prefs->dvips_cmd = "dvips -o $.ps $.dvi";
			prefs->ps2pdf_cmd = "ps2pdf $.ps";
			prefs->pdflatex_cmd = "pdflatex $.tex";
			prefs->latex2html_cmd = "latex2html $.tex";
			prefs->postscript_cmd = "gs -sDEVICE=bealpha4 $.ps";			
			TexDviCtrl->SetText(prefs->latex_cmd.String());
			DviPdfCtrl->SetText(prefs->dvipdf_cmd.String());
			DviPsCtrl->SetText(prefs->dvips_cmd.String());
			PsPdfCtrl->SetText(prefs->ps2pdf_cmd.String());
			TexPdfCtrl->SetText(prefs->pdflatex_cmd.String());
			TexHtmlCtrl->SetText(prefs->latex2html_cmd.String());
			PostScriptCtrl->SetText(prefs->postscript_cmd.String());
		}break;
		case PREFS_VIEW_RESET_TOOLBAR_DEFAULTS:
		{
			prefs->IsTexBarInverted = false;
			tb_invert_cb->SetValue(prefs->IsTexBarInverted);
			msgr->SendMessage(new BMessage(PREFS_TOOLBAR_INVALIDATE));
			prefs->IsGreekAbsent = false;
			tb_GreekHidden_cb->SetValue(!prefs->IsGreekAbsent);
			prefs->IsBigAbsent = false;
			tb_BigHidden_cb->SetValue(!prefs->IsBigAbsent);
			prefs->IsBinaryAbsent = false;
			tb_BinaryHidden_cb->SetValue(!prefs->IsBinaryAbsent);
			prefs->IsMiscAbsent = false;
			tb_MiscHidden_cb->SetValue(!prefs->IsMiscAbsent);
			prefs->IsBinRelAbsent = false;
			tb_BinRelHidden_cb->SetValue(!prefs->IsBinRelAbsent);
			prefs->IsMMAAbsent = false;
			tb_MMAHidden_cb->SetValue(!prefs->IsMMAAbsent);
			prefs->IsIntlAbsent = false;
			tb_IntlHidden_cb->SetValue(!prefs->IsIntlAbsent);
			prefs->IsTypeFaceAbsent = false;
			tb_TypeFaceHidden_cb->SetValue(!prefs->IsTypeFaceAbsent);
			prefs->IsFunctionAbsent = false;
			tb_FunctionHidden_cb->SetValue(!prefs->IsFunctionAbsent);  
			
//			msgr->SendMessage(new BMessage(PREFS_VIEW_TOOLBAR_UPDATE_ENABLED));
		}break;
		case PREFS_VIEW_RESET_GENERAL_DEFAULTS:
		{
			prefs->bubble_color = BubbleDefault;
			bubble_color_button->SetValue(prefs->bubble_color);

			prefs->IsRecentDocsPathShown = true;
			ShowRecentDocsPath_cb->SetValue(prefs->IsRecentDocsPathShown);

			prefs->IsActivationOk = true;
			IsActivationOk_cb->SetValue(prefs->IsActivationOk);

			prefs->NumRecentDocs = "20";			
			TCNumRecentDocs->SetText(prefs->NumRecentDocs.String());
			
			prefs->dateFlags = "";
			TCInsertDateFlags->SetText(prefs->dateFlags.String());
		}break;
		case PREFS_VIEW_GENERAL_SHOW_RDPATH:
		{
			prefs->IsRecentDocsPathShown = ShowRecentDocsPath_cb->Value();
		
		}break;
		case PREFS_VIEW_GENERAL_ACTIVATE_WINDOW:
		{
			prefs->IsActivationOk = IsActivationOk_cb->Value();
		}break;
		case PREFS_VIEW_GENERAL_BUBBLE_UPDATE:
		{
			prefs->bubble_color = bubble_color_button->Value();
		}break;
		case PREFS_VIEW_TOOLBAR_INVERT:
		{
			prefs->IsTexBarInverted = tb_invert_cb->Value();
			msgr->SendMessage(new BMessage(PREFS_TOOLBAR_INVALIDATE));
		}break;
		case PREFS_VIEW_OK:
		{
			prefs->latex_cmd = TexDviCtrl->Text();
			prefs->dvipdf_cmd = DviPdfCtrl->Text();
			prefs->dvips_cmd = DviPsCtrl->Text();
			prefs->ps2pdf_cmd = PsPdfCtrl->Text();
			prefs->pdflatex_cmd = TexPdfCtrl->Text();
			prefs->latex2html_cmd = TexHtmlCtrl->Text();
			prefs->postscript_cmd = PostScriptCtrl->Text();
			prefs->NumRecentDocs = TCNumRecentDocs->Text();
			prefs->dateFlags = TCInsertDateFlags->Text();
			BString str = prefs->NumRecentDocs;
			
			bool IsStrBad = false;
			for(int i=0;i<str.Length();i++)
			{
				if(!isdigit(str[i]))
				{
					IsStrBad = true;	
					break;
				}
			}
			if(!IsStrBad)
			{
				if(atoi(str.String()) > 80 || atoi(str.String()) < 0)
					str = "20";
			}
			if(IsStrBad)
				str = "20";
			
			prefs->NumRecentDocs = str;
				
			prefs->Save();
			if(prefs->fg_color != backup_prefs.fg_color ||
			prefs->bg_color != backup_prefs.bg_color ||
			prefs->generic_cmd_color != backup_prefs.generic_cmd_color ||
			prefs->format_cmd_color != backup_prefs.format_cmd_color ||
			prefs->special_cmd_color != backup_prefs.special_cmd_color ||
			prefs->math_mode_color != backup_prefs.math_mode_color ||
			prefs->comma_color != backup_prefs.comma_color ||
			prefs->comment_color != backup_prefs.comment_color ||
			prefs->punc_symbol_color != backup_prefs.punc_symbol_color)
			// ||prefs->html_color != backup_prefs.html_color)			  
				msgr->SendMessage(new BMessage(RESET_ALL_TEX_VIEW_COLORS));
			
			if(prefs->FontSize != backup_prefs.FontSize)
				msgr->SendMessage(new BMessage(RESET_ALL_TEX_VIEW_FONTS));
			
			if(prefs->IsGreekAbsent != backup_prefs.IsGreekAbsent ||
			prefs->IsBigAbsent != backup_prefs.IsBigAbsent ||
			prefs->IsBinaryAbsent != backup_prefs.IsBinaryAbsent ||
			prefs->IsMiscAbsent != backup_prefs.IsMiscAbsent ||
			prefs->IsBinRelAbsent != backup_prefs.IsBinRelAbsent ||
			prefs->IsMMAAbsent != backup_prefs.IsMMAAbsent ||
			prefs->IsIntlAbsent != backup_prefs.IsIntlAbsent ||
			prefs->IsTypeFaceAbsent != backup_prefs.IsTypeFaceAbsent ||
			prefs->IsFunctionAbsent != backup_prefs.IsFunctionAbsent)			
			{
				(new BAlert("toolbar_change","The Toolbar changes will take effect upon restart.",
				"Ok"))->Go();
				//msgr->SendMessage(new BMessage(PREFS_VIEW_TOOLBAR_UPDATE_ENABLED));			
			}
			Quit();
		}break;
		
		case PREFS_VIEW_CANCEL:
		{
			if(prefs->IsTexBarInverted != backup_prefs.IsTexBarInverted)
				msgr->SendMessage(new BMessage(PREFS_TOOLBAR_INVALIDATE));
			*prefs = backup_prefs;
			Quit();	
		}break;
		
		case PREFS_VIEW_FG_UPDATE:
		{
			prefs->fg_color = fg_color_button->Value();
			//cout << (int)prefs->fg_color.red << " " << (int)prefs->fg_color.green << " " << (int)prefs->fg_color.blue << endl; 
			tv->UpdateColors();
		}break;
		case PREFS_VIEW_BG_UPDATE:
		{
			prefs->bg_color = bg_color_button->Value();
			tv->SetViewColor(prefs->bg_color); 
			tv->Invalidate();
			//tv->UpdateColors();
		}break;
		case PREFS_VIEW_GEN_UPDATE:
		{
			prefs->generic_cmd_color = generic_cmd_color_button->Value();
			tv->UpdateColors();
		
		}break;
		case PREFS_VIEW_FORM_UPDATE:
		{
			prefs->format_cmd_color = format_cmd_color_button->Value();
			tv->UpdateColors();
		
		}break;
		case PREFS_VIEW_SPEC_UPDATE:
		{
			prefs->special_cmd_color = special_cmd_color_button->Value();
			tv->UpdateColors();
		
		}break;
		case PREFS_VIEW_MATH_UPDATE:
		{
			prefs->math_mode_color = math_mode_color_button->Value();
			tv->UpdateColors();
		
		}break;
		case PREFS_VIEW_COMA_UPDATE:
		{
			prefs->comma_color = comma_color_button->Value();
			tv->UpdateColors();
		
		}break;
		case PREFS_VIEW_COMT_UPDATE:
		{
			prefs->comment_color = comment_color_button->Value();
			tv->UpdateColors();
		
		}break;
		case PREFS_VIEW_PUNC_UPDATE:
		{
			prefs->punc_symbol_color = punc_symbol_color_button->Value();
			tv->UpdateColors();
			
		}break;
		/*case PREFS_VIEW_HTML_UPDATE:
		{
			prefs->html_color = html_color_button->Value();
			tv->UpdateColors();
			
		}break;*/
		case PREFS_VIEW_TOOLBAR_GREEK:
		{
			prefs->IsGreekAbsent = !tb_GreekHidden_cb->Value();
			//msgr->SendMessage(new BMessage(PREFS_VIEW_TOOLBAR_UPDATE_ENABLED));
		}break;
		case PREFS_VIEW_TOOLBAR_BIG:
		{
			prefs->IsBigAbsent = !tb_BigHidden_cb->Value();
			//msgr->SendMessage(new BMessage(PREFS_VIEW_TOOLBAR_UPDATE_ENABLED));
		}break;
		case PREFS_VIEW_TOOLBAR_BINARYOP:
		{
			prefs->IsBinaryAbsent = !tb_BinaryHidden_cb->Value();
			//msgr->SendMessage(new BMessage(PREFS_VIEW_TOOLBAR_UPDATE_ENABLED));
		}break;
		case PREFS_VIEW_TOOLBAR_MISC:
		{
			prefs->IsMiscAbsent = !tb_MiscHidden_cb->Value();
			//msgr->SendMessage(new BMessage(PREFS_VIEW_TOOLBAR_UPDATE_ENABLED));
		}break;
		case PREFS_VIEW_TOOLBAR_BINARYREL:
		{
			prefs->IsBinRelAbsent = !tb_BinRelHidden_cb->Value();
			//msgr->SendMessage(new BMessage(PREFS_VIEW_TOOLBAR_UPDATE_ENABLED));
		}break;
		case PREFS_VIEW_TOOLBAR_MMA:
		{
			prefs->IsMMAAbsent = !tb_MMAHidden_cb->Value();
			//msgr->SendMessage(new BMessage(PREFS_VIEW_TOOLBAR_UPDATE_ENABLED));
		}break;
		case PREFS_VIEW_TOOLBAR_INT:
		{
			prefs->IsIntlAbsent = !tb_IntlHidden_cb->Value();
			//msgr->SendMessage(new BMessage(PREFS_VIEW_TOOLBAR_UPDATE_ENABLED));
		}break;
		case PREFS_VIEW_TOOLBAR_TYPEFACE:
		{
			prefs->IsTypeFaceAbsent = !tb_TypeFaceHidden_cb->Value();
			//msgr->SendMessage(new BMessage(PREFS_VIEW_TOOLBAR_UPDATE_ENABLED));
		}break;
		case PREFS_VIEW_TOOLBAR_FUNCTION:
		{
			prefs->IsFunctionAbsent = !tb_FunctionHidden_cb->Value();
			//msgr->SendMessage(new BMessage(PREFS_VIEW_TOOLBAR_UPDATE_ENABLED));
		}break;

		default:
			BWindow::MessageReceived(msg);
	}
}
void PrefsWindow::Quit()
{
	msgr->SendMessage(new BMessage(PREFS_WINDOW_QUIT));
	BWindow::Quit();
}

