#ifndef _PREFS_WINDOW_H_
#define _PREFS_WINDOW_H_

#include <Window.h>
#include <View.h>
#include <Button.h>
#include <iostream>
#include <Messenger.h>
//#include "TexView.h"
#include "Constants.h"
#include <StringView.h>
#include <ScrollView.h>
#include <Font.h>
#include <Box.h>
#include <Alert.h>
#include "PrefsListView.h"
#include "PrefsListItem.h"
#include "ColorButton.h"
#include "Prefs.h"
#include <StringView.h>
#include "ConverterIcons.h"
#include <Slider.h>
#include <CheckBox.h>
class BitmapView : public BView
{
	public:
		BitmapView(BRect r,BBitmap* b);
		virtual void Draw(BRect r);
	private:
		BBitmap* bitmap;
};
#include <TextControl.h>
class PrefsWindow : public BWindow
{
	public:
		PrefsWindow(BRect r,BMessenger* messenger,Prefs* p);
		~PrefsWindow();
		virtual void MessageReceived(BMessage* msg);
		void Quit();
	private:
		BMessenger* msgr;
		BButton* fOk;
		BButton* fCancel;	//default btn
		
		BView* parent;
		TexView* tv;
		PrefsListView* plv;
		
		Prefs* prefs;
		Prefs backup_prefs;
		ColorButton* fg_color_button;
		ColorButton* bg_color_button;
		ColorButton* generic_cmd_color_button;
		ColorButton* format_cmd_color_button;
		ColorButton* special_cmd_color_button;
		ColorButton* math_mode_color_button;
		ColorButton* comma_color_button;
		ColorButton* comment_color_button;
		ColorButton* punc_symbol_color_button;
		//ColorButton* html_color_button;
		
		
		ColorButton* bubble_color_button;
		BTextControl* TCNumRecentDocs;
		BTextControl* TCInsertDateFlags;
		
		BCheckBox* ShowRecentDocsPath_cb;
		BCheckBox* IsActivationOk_cb;
		
		BCheckBox* tb_invert_cb;
		
		BCheckBox* tb_GreekHidden_cb;
		BCheckBox* tb_BigHidden_cb;
		BCheckBox* tb_BinaryHidden_cb;
		BCheckBox* tb_MiscHidden_cb;
		BCheckBox* tb_BinRelHidden_cb;
		BCheckBox* tb_MMAHidden_cb;
		BCheckBox* tb_IntlHidden_cb;
		BCheckBox* tb_TypeFaceHidden_cb;
		BCheckBox* tb_FunctionHidden_cb;		
		
		
		
		
		
		
		BButton* fResetColorDefaults;
		BButton* fResetCommandDefaults;
		BButton* fResetGeneralDefaults;
		BButton* fResetToolbarDefaults;
		
		BTextControl* TexDviCtrl;
		BTextControl* DviPdfCtrl;
		BTextControl* DviPsCtrl;
		BTextControl* PsPdfCtrl;
		BTextControl* TexPdfCtrl;
		BTextControl* TexHtmlCtrl;	
		BTextControl* PostScriptCtrl;
		BStringView* TextCtrlInfo;
		
		BSlider* fontsizeSlider;
};
#endif

