#ifndef _TLIST_VIEW_H
#define _TLIST_VIEW_H_

#include <ListView.h>
#include "TListItem.h"
#include <Window.h>
#include <Messenger.h>
#include <Message.h>
#include "Constants.h"
#include "SplitPane.h"
class TListView : public BListView
{
	public:
		TListView(BRect frame,BScrollView* dView);
		virtual void SelectionChanged();	
		virtual void MouseDown(BPoint point);
		virtual void MouseMoved(BPoint point,uint32 transit,const BMessage* msg);
		virtual void MessageReceived(BMessage* msg);
		void SetSP(SplitPane* sp);
		virtual void KeyDown(const char* bytes,int32 numBytes);
		int NoVisibleItems();
		void Next(int increment);
		void Prev(int decrement);
	private:
		int LastSelectedIndex;
		SplitPane* SP;
		BScrollView* docView; 
		bool IsDocViewHidden;
		uint32 button;	//last button pressed down
};

#endif //_TLIST_VIEW_H_

