#include "TWindow.h"
//const int ALPHA_AMOUNT = 255;
TWindow::~TWindow()
{
	prefs->main_window_rect = Frame();
	
	prefs->splitmsg = SP->GetState();
	prefs->split_leftmsg = LEFT->GetState();
		
	prefs->Save();
	if(helper != NULL)
		delete helper;
}
TWindow::TWindow(BRect r,Prefs* p) : BWindow(r,"BeTeX",B_DOCUMENT_WINDOW,B_ASYNCHRONOUS_CONTROLS)//B_NOT_ZOOMABLE|B_NOT_RESIZABLE)
{
	const int UPDATE_TIME = 600000000/2;	// 10/2=5 minutes
	printer_settings = NULL;
	prefs = p;//new Prefs();
	helper = new BubbleHelper(prefs);
	entry_ref betex_ref;
	TemplateDir = "";
	if(be_roster->FindApp(APP_SIG,&betex_ref) == B_OK)
	{
		BPath betex_path(&betex_ref);
		if(betex_path.InitCheck() == B_OK)
		{
			betex_path.GetParent(&betex_path);
			TemplateDir << betex_path.Path();//"/boot/home/Desktop/Templates";
			TemplateDir += "/Templates";
		}
	}	
	
	r = Bounds();
	parent = new BView(Bounds(),"parent",B_FOLLOW_ALL_SIDES,B_WILL_DRAW);
	parent->SetViewColor(ui_color(B_PANEL_BACKGROUND_COLOR));
	AddChild(parent);
	
	const int StatusBarHeight=14;
	//Setup our MenuBar
	menubar = new BMenuBar(r,"menu_bar");

	filemenu = new BMenu("File");
	
	filemenu->AddItem(fnew = new BMenuItem("New", new BMessage(MENU_FILE_NEW),'N'));
	//filemenu->AddItem(fopen = new BMenuItem("Open" B_UTF8_ELLIPSIS, new BMessage(MENU_FILE_OPEN),'O'));
	
	searchPanel = NULL;//new SearchWindow(BRect(100,100,250,250),this);
	gtlPanel = NULL;
	aboutPanel = NULL;
	prefsPanel = NULL;
	rgbTxtChooser = NULL;
	dimChooser = NULL;
	
	BMessage recentrefs;
	be_roster->GetRecentDocuments(&recentrefs,20,TEX_FILETYPE,APP_SIG);

	filemenu->AddItem(fopen = new BMenuItem(opensubmenu = new BMenu("Open" B_UTF8_ELLIPSIS),new BMessage(MENU_FILE_OPEN)));//,'O'));
	fopen->SetShortcut('O',0);
	
	filemenu->AddItem(fopentemplate = new BMenuItem(fopentemplatesubmenu = new BMenu("Open Template" B_UTF8_ELLIPSIS),/*new BMessage(MENU_FILE_OPEN)*/NULL));//,'O'));

	filemenu->AddItem(fopenfolder = new BMenuItem("Open Folder" B_UTF8_ELLIPSIS, new BMessage(MENU_FILE_OPEN_FOLDER)));
	
	filemenu->AddItem(fclose = new BMenuItem("Close", new BMessage(MENU_FILE_CLOSE),'W'));
	filemenu->AddItem(fsave = new BMenuItem("Save", new BMessage(MENU_FILE_SAVE),'S'));
	filemenu->AddItem(fsaveas = new BMenuItem("Save As" B_UTF8_ELLIPSIS, new BMessage(MENU_FILE_SAVEAS)));

	/*filemenu->AddSeparatorItem();
	
	filemenu->AddItem(fnextitem = new BMenuItem("Next Item",new BMessage(MENU_FILE_NEXT_ITEM),'I'));
	filemenu->AddItem(fprevitem = new BMenuItem("Previous Item",new BMessage(MENU_FILE_PREV_ITEM),'I',B_COMMAND_KEY|B_SHIFT_KEY));
	*/
	filemenu->AddSeparatorItem();
	filemenu->AddItem(fpgsetup = new BMenuItem("Page Setup" B_UTF8_ELLIPSIS, new BMessage(MENU_FILE_PAGE_SETUP)));
	filemenu->AddItem(fprint = new BMenuItem("Print" B_UTF8_ELLIPSIS, new BMessage(MENU_FILE_PRINT),'P'));
	
	//fpgsetup->SetEnabled(false);
	//fprint->SetEnabled(false);
	
	filemenu->AddSeparatorItem();
	
	filemenu->AddItem(fprefs = new BMenuItem("Preferences" B_UTF8_ELLIPSIS,new BMessage(MENU_FILE_PREFS)));
	fprefs->SetShortcut('P',B_SHIFT_KEY);
	filemenu->AddItem(freset_layout = new BMenuItem("Reset Layout", new BMessage(MENU_FORMAT_RESET_LAYOUT)));
	filemenu->AddItem(fabout = new BMenuItem("About BeTeX" B_UTF8_ELLIPSIS,new BMessage(MENU_FILE_ABOUT)));
	filemenu->AddItem(fquit = new BMenuItem("Quit",new BMessage(MENU_FILE_QUIT),'Q'));
	
	editmenu = new BMenu("Edit");
	
	editmenu->AddItem(fundo = new BMenuItem("Undo", new BMessage(MENU_EDIT_UNDO),'Z'));
	editmenu->AddItem(fredo = new BMenuItem("Redo", new BMessage(MENU_EDIT_REDO),'R'));
	//fundo->SetEnabled(false);
	//fredo->SetEnabled(false);
	editmenu->AddSeparatorItem();
	
	editmenu->AddItem(fcut = new BMenuItem("Cut", new BMessage(B_CUT),'X'));
	editmenu->AddItem(fcopy = new BMenuItem("Copy", new BMessage(B_COPY),'C'));
	editmenu->AddItem(fpaste = new BMenuItem("Paste", new BMessage(B_PASTE),'V'));
	
	editmenu->AddSeparatorItem();
	
	editmenu->AddItem(fselall = new BMenuItem("Select All", new BMessage(B_SELECT_ALL),'A'));
	
	editmenu->AddSeparatorItem();

	editmenu->AddItem(fsearchreplace = new BMenuItem("Find" B_UTF8_ELLIPSIS, new BMessage(MENU_EDIT_SEARCH),'F'));
	editmenu->AddItem(fgotoline = new BMenuItem("Go To Line" B_UTF8_ELLIPSIS, new BMessage(MENU_EDIT_GOTOLINE),'G'));

	
	formatmenu = new BMenu("Format");
	formatmenu->AddItem(fbold = new BMenuItem("Bold", new BMessage(MENU_FORMAT_BOLD),'B'));
	formatmenu->AddItem(femph = new BMenuItem("Emphasized", new BMessage(MENU_FORMAT_EMPH),'E'));
	formatmenu->AddItem(fital = new BMenuItem("Italic", new BMessage(MENU_FORMAT_ITAL),'I'));
	
	formatmenu->AddSeparatorItem();
	formatmenu->AddItem(fshiftleft = new BMenuItem("Shift Left", new BMessage(MENU_FORMAT_SHIFT_LEFT),'['));
	formatmenu->AddItem(fshiftright = new BMenuItem("Shift Right", new BMessage(MENU_FORMAT_SHIFT_RIGHT),']'));
	formatmenu->AddSeparatorItem();
	
	formatmenu->AddItem(fcomment = new BMenuItem("Comment Selection", new BMessage(MENU_FORMAT_COMMENTLINE)));
	formatmenu->AddItem(funcomment = new BMenuItem("UnComment Selection", new BMessage(MENU_FORMAT_UNCOMMENTLINE)));
	
	
	
	
	
	insertmenu = new BMenu("Insert");

	insertmenu->AddItem(finsertfile = new BMenuItem("File" B_UTF8_ELLIPSIS,new BMessage(MENU_INSERT_FILE)));
	insertmenu->AddItem(fdate = new BMenuItem("Date",new BMessage(MENU_INSERT_DATE)));
	insertmenu->AddItem(farray = new BMenuItem("Array",new BMessage(MENU_INSERT_ARRAY)));
	insertmenu->AddItem(fmatrix = new BMenuItem("Matrix",new BMessage(MENU_INSERT_MATRIX)));
	insertmenu->AddItem(ftabular = new BMenuItem("Tabular",new BMessage(MENU_INSERT_TABULAR)));
	insertmenu->AddItem(fequation = new BMenuItem("Equation",new BMessage(MENU_INSERT_EQUATION)));   
	insertmenu->AddItem(frgbcolor = new BMenuItem("Coloured Text",new BMessage(MENU_INSERT_COLOURED_TEXT)));
	insertmenu->AddItem(flists = new BMenuItem(flistsubmenu = new BMenu("Lists"),NULL));
	flistsubmenu->AddItem(fitemize = new BMenuItem("Itemize",new BMessage(MENU_INSERT_ITEMIZE)));
	flistsubmenu->AddItem(fdescription = new BMenuItem("Description",new BMessage(MENU_INSERT_DESCRIPTION)));
	flistsubmenu->AddItem(fenumerate = new BMenuItem("Enumerate",new BMessage(MENU_INSERT_ENUMERATE)));
	//flistsubmenu->AddItem(fcases = new BMenuItem("Cases",NULL));



	insertmenu->AddItem(fenvironments = new BMenuItem(fenvironmentssubmenu = new BMenu("Environments"),NULL));    	
	fenvironmentssubmenu->AddItem(ffigure = new BMenuItem("Figure",new BMessage(MENU_INSERT_FIGURE)));
	fenvironmentssubmenu->AddItem(ftable = new BMenuItem("Table",new BMessage(MENU_INSERT_TABLE)));
	//fenvironmentssubmenu->AddSeparatorItem();
	//fenvironmentssubmenu->AddItem(fetabular = new BMenuItem("Tabular",new BMessage(MENU_INSERT_TABULAR)));
	//fenvironmentssubmenu->AddItem(fetabularstar = new BMenuItem("Tabular*",NULL));
	//fenvironmentssubmenu->AddItem(ftabbing = new BMenuItem("Tabbing",NULL));
	fenvironmentssubmenu->AddSeparatorItem();
	fenvironmentssubmenu->AddItem(fcenter = new BMenuItem("Center",new BMessage(MENU_INSERT_CENTER)));
	fenvironmentssubmenu->AddItem(fflushleft = new BMenuItem("FlushLeft",new BMessage(MENU_INSERT_FLUSHLEFT)));
	fenvironmentssubmenu->AddItem(fflushright = new BMenuItem("FlushRight",new BMessage(MENU_INSERT_FLUSHRIGHT)));
	fenvironmentssubmenu->AddSeparatorItem();
	fenvironmentssubmenu->AddItem(feqnarray = new BMenuItem("EqnArray",new BMessage(MENU_INSERT_EQNARRAY)));
	fenvironmentssubmenu->AddItem(ffeqnarraystar = new BMenuItem("EqnArray*",new BMessage(MENU_INSERT_EQNARRAY_STAR)));
	fenvironmentssubmenu->AddSeparatorItem();
	fenvironmentssubmenu->AddItem(fverbatim = new BMenuItem("Verbatim",new BMessage(MENU_INSERT_VERBATIM)));
	fenvironmentssubmenu->AddItem(fquote = new BMenuItem("Quote",new BMessage(MENU_INSERT_QUOTE)));
	//fenvironmentssubmenu->AddItem(fminipage = new BMenuItem("MiniPage",NULL));
	
	compilemenu = new BMenu("Compile");
	compilemenu->AddItem(ftexdvi = new BMenuItem("tex->dvi", new BMessage(CMD_COMPILE_TEXDVI),'1'));
	compilemenu->AddItem(fdvipdf = new BMenuItem("dvi->pdf", new BMessage(CMD_COMPILE_DVIPDF),'2'));
	compilemenu->AddItem(fdvips = new BMenuItem("dvi->ps", new BMessage(CMD_COMPILE_DVIPS),'3'));
	compilemenu->AddItem(fpspdf = new BMenuItem("ps->pdf", new BMessage(CMD_COMPILE_PSPDF),'4'));
	compilemenu->AddItem(ftexpdf = new BMenuItem("tex->pdf", new BMessage(CMD_COMPILE_TEXPDF),'5'));
	compilemenu->AddItem(ftexhtml = new BMenuItem("tex->html", new BMessage(CMD_COMPILE_TEXHTML),'6'));

	previewmenu = new BMenu("Preview");
	previewmenu->AddItem(fpostscript = new BMenuItem("Postscript" B_UTF8_ELLIPSIS, new BMessage(CMD_LAUNCH_PSVIEWER),'7'));
	previewmenu->AddItem(fpdf = new BMenuItem("Pdf" B_UTF8_ELLIPSIS, new BMessage(CMD_LAUNCH_BE_PDF),'8'));
	previewmenu->AddItem(fhtml = new BMenuItem("Html" B_UTF8_ELLIPSIS, new BMessage(CMD_LAUNCH_HTMLVIEWER),'9'));
	
	menubar->AddItem(filemenu);
	menubar->AddItem(editmenu);
	menubar->AddItem(formatmenu);
	menubar->AddItem(insertmenu);
	menubar->AddItem(compilemenu);
	menubar->AddItem(previewmenu);
	
	parent->AddChild(menubar);

	//Setup SaveFilePanel
	savePanel = new BFilePanel(B_SAVE_PANEL,NULL,NULL,B_FILE_NODE,false,NULL,new TexFileFilter()); 
	savePanel->SetTarget(this);
	
	//Setup OpenFilePanel
	openPanel = new BFilePanel(B_OPEN_PANEL,NULL,NULL,B_FILE_NODE,true,NULL,new TexFileFilter());
	openPanel->SetTarget(this);
	
	openfolderPanel = new BFilePanel(B_OPEN_PANEL,NULL,NULL,B_DIRECTORY_NODE,true);
	openfolderPanel->SetTarget(this);
	insertfilePanel = new BFilePanel(B_OPEN_PANEL,NULL,NULL,B_FILE_NODE,false,new BMessage(MENU_INSERT_FILE_RECEIVED),new TexFileFilter());
	insertfilePanel->SetTarget(this);
	BRect mbframe = menubar->Frame();
	float height = mbframe.bottom-mbframe.top;
	r = Bounds();
	
	r.bottom-=StatusBarHeight;
	
	r.top += height+1;
	
	mtbar = new MainTBar(BRect(r.left,r.top,r.left+545,r.top+35),helper);
	parent->AddChild(mtbar);
	r.top += 36+3;
	
	TLIST_VIEW_WIDTH=178;//146;//147
	BRect Trect(0,0,r.Width(),r.Height()-StatusBarHeight);
	BRect Textrect = Trect;
	Textrect.InsetBy(10,10);

	DocView* docView = new DocView(Trect);//,Textrect);
	docScroll = new BScrollView("ScrollView",docView,B_FOLLOW_LEFT | B_FOLLOW_TOP,B_WILL_DRAW|B_FRAME_EVENTS,false,true);
	
	
	toolbar = new TexBar(BRect(0,(r.Height()/2)-99,TLIST_VIEW_WIDTH,r.Height()-StatusBarHeight),helper,prefs);
	
	BScrollView* tbscroller = new BScrollView("tbscroller",toolbar,B_FOLLOW_LEFT | B_FOLLOW_TOP,B_WILL_DRAW|B_FRAME_EVENTS,false,true);
	listview = new TListView(BRect(0,0,TLIST_VIEW_WIDTH,r.Height()/2-100),docScroll);
	LEFT = new SplitPane(BRect(0,r.top,TLIST_VIEW_WIDTH,r.Height()),new BScrollView("ScrollView",listview,B_FOLLOW_LEFT | B_FOLLOW_TOP,B_WILL_DRAW|B_FRAME_EVENTS,false,true),tbscroller,B_FOLLOW_ALL_SIDES);
	
	LEFT->SetAlignment(B_HORIZONTAL);
	LEFT->SetEditable(false);
	LEFT_BAR_V_POS = r.Height()/4;
	LEFT->SetBarPosition(LEFT_BAR_V_POS);
	//LEFT->SetBarAlignmentLocked(true);
	//LEFT->SetMinSizeOne(100);
	SP = new SplitPane(r,LEFT,docScroll,B_FOLLOW_ALL_SIDES);
	
	listview->SetSP(SP);

	SP->SetAlignment(B_VERTICAL);
	SP->SetEditable(false);
	
	SP->SetBarPosition(TLIST_VIEW_WIDTH);
	//SP->SetBarAlignmentLocked(true);
	
	//SP->SetBarLocked(true);				//LOCK FOR NOW
	//SP->SetMinSizeOne(TLIST_VIEW_WIDTH);

	parent->AddChild(SP);
	
	untitled_no = 1;
	
	
	if(prefs->splitmsg == NULL && prefs->split_leftmsg == NULL)
	{
		prefs->splitmsg = SP->GetState();
		prefs->split_leftmsg = LEFT->GetState();
	}
	else
	{
		SP->SetState(prefs->splitmsg);
		LEFT->SetState(prefs->split_leftmsg);		
	}	
	//SPstate->PrintToStream();
	//LEFTstate->PrintToStream();
	//SP->SetState(LEFTstate);
	
	//docScroll->Hide();
	//NewDocument();
	/*if(!prefs->splitmsg.IsEmpty())
 		SP->SetState(&prefs->splitmsg);
	else
		prefs->splitmsg = *(SP->GetState());

	if(!prefs->split_leftmsg.IsEmpty())
	 	LEFT->SetState(&prefs->split_leftmsg);
	else
		prefs->split_leftmsg = *(LEFT->GetState());
	
	prefs->Save();
	*/
	r = Bounds();
	r.top = r.bottom-StatusBarHeight;
	StatusBar = new zStatusView(r);
	parent->AddChild(StatusBar);
	StatusBar->SetText("BeTeX");
	RemoveAfterSave = false;
	
	ResetPermissions();
	

}

bool TWindow::PromptToQuit()
{
	TListItem* li;
	for(int i=0;i<listview->CountItems();i++)
	{
		TListItem* li = (TListItem*)listview->ItemAt(i);
		if(li->IsSaveNeeded())
			return true;
	}		
	return false;
}
bool TWindow::QuitRequested()
{
	//bool OkToQuit = !PromptToQuit();
	//if(OkToQuit)
		be_app->PostMessage(B_QUIT_REQUESTED);
	return !PromptToQuit();
}
void TWindow::SaveAsPanel(int32 index)
{
		if(index >= 0)
		{
			TListItem* li = (TListItem*)listview->ItemAt(index);
			savePanel->SetSaveText(li->FName());	
			savePanel->Show();
		}
}
void TWindow::InsertText(const char* text)
{
	//TListItem* it = CurrentTListItem;
	TexView* tv = CurrentTexView();
	if(tv != NULL)
	{
		BString cmd(text);
		int lbrk,rbrk;
		lbrk=cmd.FindLast('{');
		rbrk=cmd.FindLast('}');
		bool InsertTextIntoBrk= (lbrk >= 0 && rbrk >= 0 && rbrk-lbrk == 1);
		int32 start,finish;
		tv->GetSelection(&start,&finish);
		if(start != finish)
		{
			if(InsertTextIntoBrk)
			{
				BString leftstr;
				cmd.CopyInto(leftstr,0,lbrk+1);
				BString rightstr;
				cmd.CopyInto(rightstr,rbrk,cmd.Length()-rbrk);
				
				tv->Insert(start,leftstr.String(),leftstr.Length(),NULL);
				tv->Insert(finish+leftstr.Length(),rightstr.String(),rightstr.Length(),NULL);
				tv->Select(finish+rightstr.Length()+leftstr.Length(),finish+rightstr.Length()+leftstr.Length());
			}
			else
			{
				tv->Delete(start,finish);
				tv->Insert(start,cmd.String(),cmd.Length(),NULL);
				tv->Select(start+cmd.Length(),start+cmd.Length());
			}
		}
		else
		{
			tv->Insert(start,cmd.String(),cmd.Length(),NULL);
			if(InsertTextIntoBrk)
				tv->Select(start+cmd.Length()-1,start+cmd.Length()-1);
			else
				tv->Select(start+cmd.Length(),start+cmd.Length());
		}
		tv->ScrollToSelection();
	}		
}
void TWindow::UpdateStatusBar()
{
	int current = listview->CurrentSelection();
	if(listview->CountItems() == 0 || current < 0)
			StatusBar->SetText("BeTeX");
	
	else
	{
		
		if(current >= 0)
		{
			TexView* tv = CurrentTexView();
			TListItem* item = CurrentTListItem();
			
			if(tv == NULL || item == NULL)
				return;
			
			BString displayme;

			int32 offset,finish;
			tv->GetSelection(&offset,&finish);
			
			vector<int> sols;
			vector<int> eols;
			tv->FillSolEol(sols,eols,0,tv->TextLength()-1);
			//cout << sols.size() << " " << eols.size() << endl;
			int line=sols.size();
			for(int i=sols.size()-1;i>=0;i--)
			{
				if(offset >= sols[i])// && offset <= eols[i])
				{	
					line = i;
					break;
				}	
			}
			if(line < 0)
				displayme << item->FName();
			else
			{
				int position=offset-sols[line];
				line++;
				position++;
				//last lines don't display........ :P
				displayme << item->FName() << " [" << (int)line << "," << (int) position << "]";
			}				
			StatusBar->SetText(displayme.String());
		}
	}		
}
TexView* TWindow::CurrentTexView()
{
	int current = listview->CurrentSelection();
	if(current >= 0)
	{
		TexView* tv;
		TListItem* item;
		item = (TListItem*)listview->ItemAt(current);
		tv = (TexView*)item->TextView();
		return tv;
	}
	return NULL;
}
TListItem* TWindow::CurrentTListItem()
{
	int current = listview->CurrentSelection();
	if(current >= 0)
	{
		TListItem* item;
		item = (TListItem*)listview->ItemAt(current);
		return item;
	}
	return NULL;
}
void TWindow::Execute(char* script,const char* cmd)
{
	int current = listview->CurrentSelection();
	if(current >=0)
	{
		//$ Terminal /boot/beos/bin/sh -c "echo crap" 
		TListItem* li = (TListItem*)listview->ItemAt(current);
		entry_ref ref = li->GetRef();
		BPath path(&ref);
		if(path.InitCheck() == B_OK)
		{
			BPath parent;
			path.GetParent(&parent);
			
			BString initial;
			initial << "#!/bin/sh\n" << "cd \"" << parent.Path() << "\"\n";
			BString sourceme;
			sourceme << "source ~/.profile\n";
			BString command;
			command << cmd << "\n";
			BString fname;
			fname << path.Leaf();
			fname.Replace(".tex","",1);
			command.ReplaceAll("$",fname.String());
			
			BString echostr;
			echostr << "echo \"\\$ " << command.String() << "\"";
			echostr.ReplaceAll("\n","");
			echostr << "\n";
			
			BString end;
			end << "echo \"(Press Enter To Continue)\"\nread\nexit 0\n";
			
			BFile file(script,B_READ_WRITE | B_CREATE_FILE | B_ERASE_FILE);
			
			if(file.InitCheck() == B_OK)
			{
				file.Write(initial.String(),initial.Length());
				file.Write(sourceme.String(),sourceme.Length()); 
				file.Write(echostr.String(),echostr.Length()); 
				file.Write(command.String(),command.Length());
				file.Write(end.String(),end.Length());
				file.Unset();
				char *args[] = {script, NULL};
				be_roster->Launch("application/x-vnd.Be-SHEL",1,args);
				
			}	
		}
	}
	ResetPermissions();
}
void TWindow::ResetPermissions()
{
	TexView* tv = CurrentTexView();
	TListItem* li = CurrentTListItem();
	if(tv == NULL)
	{
		//disable those things not used......
		//edit items
		fclose->SetEnabled(false);
		fsave->SetEnabled(false);
		fsaveas->SetEnabled(false);
		fpgsetup->SetEnabled(false);
		fprint->SetEnabled(false);
		//edit items
		fundo->SetEnabled(false);
		fredo->SetEnabled(false);
		
		fbold->SetEnabled(false);
		femph->SetEnabled(false);
		fital->SetEnabled(false);
		fshiftleft->SetEnabled(false);
		fshiftright->SetEnabled(false);
		
		
		
		fcut->SetEnabled(false);
		fcopy->SetEnabled(false);
		fpaste->SetEnabled(false);
		fselall->SetEnabled(false);
		fsearchreplace->SetEnabled(false);
		fgotoline->SetEnabled(false);
		fcomment->SetEnabled(false);
		funcomment->SetEnabled(false);
		
		ftexdvi->SetEnabled(false);
		fdvipdf->SetEnabled(false);
		fdvips->SetEnabled(false);
		fpspdf->SetEnabled(false);
		ftexpdf->SetEnabled(false);
		ftexhtml->SetEnabled(false);
		
		fpostscript->SetEnabled(false);
		fpdf->SetEnabled(false);
		fhtml->SetEnabled(false);
		
		mtbar->TBSave->SetEnabled(false);
		mtbar->TBPrint->SetEnabled(false);
		//mtbar->TBDelTmp->SetEnabled(false);
		mtbar->TBViewLog->SetEnabled(false);
		mtbar->TBTexDvi->SetEnabled(false);
		mtbar->TBDviPdf->SetEnabled(false);
		mtbar->TBDviPs->SetEnabled(false);
		mtbar->TBPsPdf->SetEnabled(false);
		mtbar->TBTexDvi->SetEnabled(false);
		mtbar->TBTexPdf->SetEnabled(false);
		mtbar->TBTexHtml->SetEnabled(false);
		
		mtbar->TBOpenTracker->SetEnabled(false);
		mtbar->TBOpenTerminal->SetEnabled(false);
		mtbar->TBPrevPDF->SetEnabled(false);
		mtbar->TBPrevPS->SetEnabled(false);
		mtbar->TBPrevHTML->SetEnabled(false);
		//mtbar->TBDelTmp->SetAuxIcon(true);
		
		
		finsertfile->SetEnabled(false);
		fdate->SetEnabled(false);
		farray->SetEnabled(false);
		fmatrix->SetEnabled(false);
		ftabular->SetEnabled(false);
		fequation->SetEnabled(false);
		frgbcolor->SetEnabled(false);
		flists->SetEnabled(false);
		flistsubmenu->SetEnabled(false);
		/*
		fitemize->SetEnabled(false);
		fdescription->SetEnabled(false);
		fenumerate->SetEnabled(false);
		*/
		//fcases->SetEnabled(false);
		fenvironments->SetEnabled(false);
		fenvironmentssubmenu->SetEnabled(false);
		/*ffigure->SetEnabled(false);
		ftable->SetEnabled(false);
		//fetabular->SetEnabled(false);
		//fetabularstar->SetEnabled(false);
		//ftabbing->SetEnabled(false);
		fcenter->SetEnabled(false);
		fflushleft->SetEnabled(false);
		fflushright->SetEnabled(false);
		feqnarray->SetEnabled(false);
		ffeqnarraystar->SetEnabled(false);
		fquote->SetEnabled(false);
		//fminipage->SetEnabled(false);
		*/
	}
	else
	{
	
		bool DoesPdfExist = false;
		bool DoesPsExist = false;
		bool DoesDviExist = false;
		bool DoesHtmlExist = false;
		bool DoesLogExist = false;
		bool DoesTexExist = li->IsHomely();
		
		bool IsSomeTextPasteable = false;
		
		bool IsSaveNeeded = li->IsSaveNeeded() || !DoesTexExist;
		
		bool IsNonZeroText = tv->TextLength() > 0;
		int32 start,finish;
		tv->GetSelection(&start,&finish);
		bool IsSomeTextSelected = (start != finish);
		
		BPath parent;
		entry_ref ref = li->GetRef();
		TexPath.SetTo(&ref);
		if(TexPath.InitCheck() == B_OK)
		{
			basename = "";
			basename << TexPath.Leaf();
			basename.Replace(".tex","",1);
	
			
			TexPath.GetParent(&parent);
			parent_dir = parent;
		}

		if(DoesTexExist)
		{
			BString pdf_path;
			BString dvi_path;
			BString ps_path;
			BString html_path;
			BString log_path;
			
			pdf_path << TexPath.Path();
			pdf_path.Replace(".tex",".pdf",1);
			
			log_path << TexPath.Path();
			log_path.Replace(".tex",".log",1);
			
			ps_path << TexPath.Path();
			ps_path.Replace(".tex",".ps",1);
			dvi_path << TexPath.Path();
			dvi_path.Replace(".tex",".dvi",1);
			html_path << parent_dir.Path() << "/" << basename.String() << "/" << basename.String() << ".html";
				
			BEntry log_entry(log_path.String());
			BEntry pdf_entry(pdf_path.String());
			BEntry ps_entry(ps_path.String());
			BEntry dvi_entry(dvi_path.String());
			BEntry html_entry(html_path.String());
			
			DoesPdfExist = pdf_entry.Exists();
			DoesPsExist = ps_entry.Exists();
			DoesDviExist = dvi_entry.Exists();
			DoesHtmlExist = html_entry.Exists();
			DoesLogExist = log_entry.Exists();
		}
		//Main Toolbar Buttons
	
		mtbar->TBPrint->SetEnabled(IsNonZeroText);
		mtbar->TBSave->SetEnabled(IsSaveNeeded);
	
		mtbar->TBViewLog->SetEnabled(DoesLogExist);
		mtbar->TBTexDvi->SetEnabled(DoesTexExist);
		mtbar->TBDviPdf->SetEnabled(DoesDviExist);
		mtbar->TBDviPs->SetEnabled(DoesDviExist);
		mtbar->TBPsPdf->SetEnabled(DoesPsExist);
		mtbar->TBTexDvi->SetEnabled(DoesTexExist);
		mtbar->TBTexPdf->SetEnabled(DoesTexExist);
		mtbar->TBTexHtml->SetEnabled(DoesTexExist);
		
		mtbar->TBOpenTracker->SetEnabled(DoesTexExist);
		mtbar->TBOpenTerminal->SetEnabled(DoesTexExist);
		mtbar->TBPrevPDF->SetEnabled(DoesPdfExist);
		mtbar->TBPrevPS->SetEnabled(DoesPsExist);
		mtbar->TBPrevHTML->SetEnabled(DoesHtmlExist);
			
		//Menu Items
		fprint->SetEnabled(IsNonZeroText);
		fpgsetup->SetEnabled(IsNonZeroText);
		fsave->SetEnabled(IsSaveNeeded);
		fsaveas->SetEnabled(true);//IsSaveNeeded);
		
		fclose->SetEnabled(true);
		fbold->SetEnabled(true);
		femph->SetEnabled(true);
		fital->SetEnabled(true);


		finsertfile->SetEnabled(true);
		fdate->SetEnabled(true);
		farray->SetEnabled(true);
		fmatrix->SetEnabled(true);
		ftabular->SetEnabled(true);
		fequation->SetEnabled(true);
		frgbcolor->SetEnabled(true);
		flists->SetEnabled(true);
		flistsubmenu->SetEnabled(true);
		/*
		fitemize->SetEnabled(true);
		fdescription->SetEnabled(true);
		fenumerate->SetEnabled(true);
		*/
		//fcases->SetEnabled(true);
		fenvironments->SetEnabled(true);
		fenvironmentssubmenu->SetEnabled(true);

		//always off
		fundo->SetEnabled(false);
		fredo->SetEnabled(false);

		fcut->SetEnabled(IsSomeTextSelected);
		fcopy->SetEnabled(IsSomeTextSelected);

		fshiftleft->SetEnabled(true);//IsSomeTextSelected);
		fshiftright->SetEnabled(true);//IsSomeTextSelected);

	
		fselall->SetEnabled(!IsSomeTextSelected);
		fcomment->SetEnabled(IsSomeTextSelected);
		funcomment->SetEnabled(IsSomeTextSelected);
		
		fsearchreplace->SetEnabled(true);
		fgotoline->SetEnabled(true);
	
		const char* cliptext;
		int32 length;
		BMessage* clip = NULL;
		
		
		//should do some watching.....
		if(be_clipboard->Lock())
		{
			
			IsSomeTextPasteable = ((clip = be_clipboard->Data()));//if((clip = be_clip
			be_clipboard->Unlock();
		}
		
		fpaste->SetEnabled(IsSomeTextPasteable);
		
		ftexdvi->SetEnabled(DoesTexExist);
		fdvipdf->SetEnabled(DoesDviExist);
		fdvips->SetEnabled(DoesDviExist);
		fpspdf->SetEnabled(DoesPsExist);
		ftexpdf->SetEnabled(DoesTexExist);
		ftexhtml->SetEnabled(DoesTexExist);
	
		fpostscript->SetEnabled(DoesPsExist);
		fpdf->SetEnabled(DoesPdfExist);
		fhtml->SetEnabled(DoesHtmlExist);
			
	
		//Setup some node monitoring......
		if(TexPath.InitCheck() == B_OK && DoesTexExist)
		{
		
			bool IsAlreadyWatched=false;
			for(int i=0;i<watchedPaths.size();i++)
			{
				if(parent == watchedPaths[i])
				{
					IsAlreadyWatched = true;
					break;
				}
			}
			
			
			if(!IsAlreadyWatched)
			{
				
				
				watchedPaths.push_back(parent);
				
				node_ref nref;
				BEntry parent_entry(parent.Path());
				if(parent_entry.InitCheck() == B_OK)
				{
					parent_entry.GetNodeRef(&nref);
					BMessenger msgr(this);
					
					if(watch_node(&nref,B_WATCH_DIRECTORY,msgr) != B_OK)
						cout << "err watching: " << parent.Path() << endl;
					
				}
					node_ref nref_latex2htmlfolder;
					BString latex2html_dir;
					latex2html_dir << parent_dir.Path() << "/" << basename;
					BEntry latex2html_entry(latex2html_dir.String());
					if(latex2html_entry.InitCheck() == B_OK)
					{
						latex2html_entry.GetNodeRef(&nref_latex2htmlfolder);
						BMessenger msgr(this);
						if(watch_node(&nref_latex2htmlfolder,B_WATCH_DIRECTORY,msgr) != B_OK)
						cout << "err watching latex2html folder" << endl;
						//&& watch_node(&nref_latex2htmlfolder,B_WATCH_DIRECTORY,msgr) == B_OK)
					}				
			}
		}
		
	}
}
status_t TWindow::PageSetup(const char* fname)
{
	status_t result = B_OK;
	
	BPrintJob job(fname);
	
	if(printer_settings != NULL)
		job.SetSettings(new BMessage(*printer_settings));
		
	result = job.ConfigPage();
	
	if(result == B_NO_ERROR)
	{
		delete printer_settings;
		printer_settings = job.Settings();
	}
	return result;
}
void TWindow::Print()
{
			//printer_settings
			status_t result = B_OK;
			TexView* tv = CurrentTexView();
			TListItem* it = CurrentTListItem();
			
			BRect paper_rect;
			BRect printable_rect;
			BRect old_text_rect;
			if(tv != NULL && it != NULL && tv->TextLength() != 0)
			{
				old_text_rect = tv->TextRect();
				if(printer_settings == NULL)
				{
					result = PageSetup(it->FName());//job.ConfigPage();
					if(result != B_OK)
					{
						return;
					}
				}
				BPrintJob job(it->FName());
				
					//setup the driver with user settings
					job.SetSettings(new BMessage(*printer_settings));
					
					result = job.ConfigJob();
					if(result != B_OK)
						return;
						
						
						//printer_settings = job.Settings();
						//use new settings for internal use
						//may have changed
						paper_rect = job.PaperRect();
						printable_rect = job.PrintableRect();
						
						BRect resize_to_me(printable_rect);
						resize_to_me.top-=20;
						resize_to_me.right -= 10;
						tv->SetTextRect(resize_to_me);
						
						//Time to get num of pages...
						//pages are zero-based
						int32 firstPage = job.FirstPage();
						int32 lastPage = job.LastPage();
						
						int32 firstLine = 0;
						int32 lastLine = tv->CountPhysicalLines();
						
						int32 pagesInDocument = 1;
						int32 linesInDocument = tv->CountPhysicalLines();
						
						int32 currentLine = 0;
						while(currentLine < linesInDocument)
						{
							float currentHeight = 0;
							while((currentHeight < printable_rect.Height()) &&
							(currentLine < linesInDocument))
							{
								currentHeight += tv->LineHeight(currentLine);
								if(currentHeight < printable_rect.Height())
									currentLine++;
							}
							
							if(pagesInDocument == lastPage)
								lastLine = currentLine;
							if(currentHeight >= printable_rect.Height())
							{
								pagesInDocument++;
								if(pagesInDocument == firstPage)
									firstLine = currentLine;
							}
						}
						
						if(lastPage > pagesInDocument - 1)
						{
							lastPage = pagesInDocument - 1;
							lastLine = currentLine - 1;
						}
						
						
						
						
						//Verify that the range is correct
						// 0 ... LONG_MAX -> Print all the document
						// n ... LONG_MAX -> Print from page n to the end
						// n ... m -> Print from page n to page m
						
						
						int32 numPages = lastPage - firstPage + 1;
						
						//Verify range is correct
						if(numPages <= 0)
							return;
							
						//Now we can print the page
						job.BeginJob();
						
						//Print all pages
						bool can_continue = job.CanContinue();

						int32 printLine = firstLine;
						while (printLine < lastLine)
						{
							float currentHeight = 0;
							int32 firstLineOnPage = printLine;
							while ((currentHeight < printable_rect.Height()) && (printLine < lastLine)) 
							{
								currentHeight += tv->LineHeight(printLine);
								if (currentHeight < printable_rect.Height()) 
									printLine++;
								
							}
							float top = 0;
							if (firstLineOnPage != 0)
								top = tv->TextHeight(0,firstLineOnPage-1);
							int TEXT_INSET = 0;
							float bottom = tv->TextHeight(0,printLine-1);
							BRect textRect(0.0,top+TEXT_INSET,printable_rect.Width(),bottom+TEXT_INSET);
							job.DrawView(tv,textRect,BPoint(0.0,0.0));
							job.SpoolPage();
						}
						job.CommitJob();
						tv->SetTextRect(old_text_rect);
						
					
						
					
				}

}
void TWindow::MessageReceived(BMessage* msg)
{
	//msg->PrintToStream();
	switch(msg->what)
	{	
		case MENU_FORMAT_RESET_LAYOUT:
		{
			LEFT->SetAlignment(B_HORIZONTAL);
			LEFT->SetEditable(false);
			LEFT->SetBarPosition(LEFT_BAR_V_POS);
			SP->SetAlignment(B_VERTICAL);
			SP->SetEditable(false);
			SP->SetBarPosition(TLIST_VIEW_WIDTH);
			prefs->splitmsg = SP->GetState();
			prefs->split_leftmsg = LEFT->GetState();
		}
		break;
		case MENU_INSERT_DATE:
		{
			TexView* tv = CurrentTexView();
			if(tv != NULL)
			{
				//Avert your eyes! This isn't nice code :-)
				int MAX_BUF=100;
				BString cmd="";
				cmd << "date " << prefs->dateFlags.String();
				FILE* ptr = popen(cmd.String(),"r");
				char buf[MAX_BUF+1];
				int size;
				memset(buf,'\0',sizeof(buf));
				if(ptr != NULL)
				{
					size = fread(buf,sizeof(char),MAX_BUF,ptr);
					while(size > 0)
					{
						buf[size-1] = '\0';
						size = fread(buf,sizeof(char),MAX_BUF,ptr);
					}
					pclose(ptr);
				}
				InsertText(buf);
			}
		}break;
		case MENU_INSERT_FILE_RECEIVED:
		{
			//open file, get contents, insert contents
			TexView* tv = CurrentTexView();
			if(tv != NULL)
			{
				entry_ref ref;
				if(msg->FindRef("refs",&ref) == B_OK)
				{
					BFile file(&ref,B_READ_ONLY);
					if(file.InitCheck() == B_OK)
					{
						off_t size;
						if(file.GetSize(&size) == B_OK)
						{
							char buf[size+1];
							file.Read(buf,size);
							buf[size] = '\0';
							InsertText(buf);
						}
					}
				}
			}							
		}break;
		case MENU_INSERT_FILE:
		{
			insertfilePanel->Show();
		
		}break;
		case MENU_INSERT_ARRAY:
		{
				//launch colour chooser window
				if(dimChooser != NULL)
				{
					dimChooser->Activate(true);
					break;
				}
				BPoint p;
				uint32 buttons;
				parent->GetMouse(&p,&buttons);
				parent->ConvertToScreen(&p);
				p.x-=30;
				p.y-=30;
				float w=150,h=115;
				dimChooser = new DimensionWindow(BRect(p.x,p.y,p.x+w,p.y+h),new BMessenger(this),prefs,MENU_INSERT_ARRAY_WITHDIM);
				dimChooser->Show();
		
		
		}break;
		case MENU_INSERT_ARRAY_WITHDIM:
		{
			int32 rows=atoi(prefs->Rows.String());
			int32 cols=atoi(prefs->Cols.String());

				BString insert="\\begin{array}{";
				int i;
				int j;
				for(i=0;i<cols;i++)
				{
					insert << "c";
				}
				insert << "}\n";
				for(j=0;j<rows;j++)
				{
					for(i=0;i<cols;i++)
					{
						if(i+1 != cols)
							insert << "* & ";
						else
							insert << "* \\\\\n";
					}
				}
				insert << "\\end{array}\n";	
				InsertText(insert.String());
		}break;
	
		case MENU_INSERT_MATRIX:
		{
				//launch colour chooser window
				if(dimChooser != NULL)
				{
					dimChooser->Activate(true);
					break;
				}
				BPoint p;
				uint32 buttons;
				parent->GetMouse(&p,&buttons);
				parent->ConvertToScreen(&p);
				p.x-=30;
				p.y-=30;
				float w=150,h=115;
				dimChooser = new DimensionWindow(BRect(p.x,p.y,p.x+w,p.y+h),new BMessenger(this),prefs,MENU_INSERT_MATRIX_WITHDIM);
				dimChooser->Show();
		
		
		}break;
		case MENU_INSERT_MATRIX_WITHDIM:
		{
			int32 rows=atoi(prefs->Rows.String());
			int32 cols=atoi(prefs->Cols.String());

				BString insert="\\left(\n\\begin{array}{";
				int i;
				int j;
				for(i=0;i<cols;i++)
				{
					insert << "c";
				}
				insert << "}\n";
				for(j=0;j<rows;j++)
				{
					for(i=0;i<cols;i++)
					{
						if(i+1 != cols)
							insert << "* & ";
						else
							insert << "* \\\\\n";
					}
				}
				insert << "\\end{array}\n\\right)\n";	
				InsertText(insert.String());
		}break;

		case MENU_INSERT_TABULAR:
		{
				//launch colour chooser window
				if(dimChooser != NULL)
				{
					dimChooser->Activate(true);
					break;
				}
				BPoint p;
				uint32 buttons;
				parent->GetMouse(&p,&buttons);
				parent->ConvertToScreen(&p);
				p.x-=30;
				p.y-=30;
				float w=150,h=115;
				dimChooser = new DimensionWindow(BRect(p.x,p.y,p.x+w,p.y+h),new BMessenger(this),prefs,MENU_INSERT_TABULAR_WITHDIM);
				dimChooser->Show();
		
		
		}break;
		case MENU_INSERT_TABULAR_WITHDIM:
		{
			int32 rows=atoi(prefs->Rows.String());
			int32 cols=atoi(prefs->Cols.String());

				BString insert="\\begin{tabular}{|";
				int i;
				int j;
				for(i=0;i<cols;i++)
				{
					insert << "c|";
				}
				insert << "}\n\\hline\n";
				for(j=0;j<rows;j++)
				{
					if(j == 1)
						insert << "\\hline\n";
					for(i=0;i<cols;i++)
					{
						if(i+1 != cols)
							insert << "* & ";
						else
							insert << "* \\\\\n";
					}
				}
				insert << "\\hline\n\\end{tabular}\n";	
				InsertText(insert.String());
		}break;
		case DIM_WINDOW_QUIT:
		{
			dimChooser = NULL;
		
		}break;
		case MENU_INSERT_EQNARRAY:
		{
			InsertText("\\begin{eqnarray}\n\t* & = & * \\\\\n\t* & = & * \n\\end{eqnarray}\n");
		}break;
		case MENU_INSERT_EQNARRAY_STAR:
		{
			InsertText("\\begin{eqnarray*}\n\t* & = & * \\\\\n\t* & = & * \n\\end{eqnarray*}\n");
		}break;
		case MENU_INSERT_VERBATIM:
		{
			InsertText("\\begin{verbatim}\n\n\\end{verbatim}\n");
		}break;
		case MENU_INSERT_QUOTE:
		{
			InsertText("\\begin{quote}\n\n\\end{quote}\n");
		}break;
		case MENU_INSERT_TABLE:
		{
			//%Insert Tabular Environment Here\n\t
			InsertText("\\begin{table}\n\t\\centering\n\t\\caption{*}\n\t\\label{*}\n\\end{table}\n");
		}break;
		case MENU_INSERT_FIGURE:
		{
			InsertText("\\begin{figure}\n\t\\includegraphics[*]{*}\n\t\\caption{*}\n\t\\label{*}\n\\end{figure}\n");
		
		}break;
		
		case MENU_INSERT_CENTER:
		{
			InsertText("\\begin{center}\n\n\\end{center}\n");
		
		}break;
		case MENU_INSERT_FLUSHLEFT:
		{
			InsertText("\\begin{flushleft}\n\n\\end{flushleft}\n");
		
		}break;
		case MENU_INSERT_FLUSHRIGHT:
		{
			InsertText("\\begin{flushright}\n\n\\end{flushright}\n");
		
		}break;
		case MENU_INSERT_ITEMIZE:
		{
			//\begin{itemize}
			//  \item *
			//  \item *
			//\end{itemize}
						
			InsertText("\\begin{itemize}\n\t\\item *\n\t\\item *\n\\end{itemize}\n");
		}break;
		case MENU_INSERT_DESCRIPTION:
		{
			/*\begin{description}
			    \item[*] *
			    \item[*] *
			\end{description}
			*/			
			InsertText("\\begin{description}\n\t\\item[*] *\n\t\\item[*] *\n\\end{description}\n");
		}break;
		case MENU_INSERT_ENUMERATE:
		{
			//\begin{itemize}
			//  \item *
			//  \item *
			//\end{itemize}
			InsertText("\\begin{enumerate}\n\t\\item *\n\t\\item *\n\\end{enumerate}\n");
		}break;
		case MENU_INSERT_EQUATION:
		{
			InsertText("\\begin{equation}\\label{*}\n\t*\n\\end{equation}\n");
		}break;
		case MENU_INSERT_COLOURED_TEXT:
		{
			if(CurrentTListItem() != NULL)
			{
				//launch colour chooser window
				if(rgbTxtChooser != NULL)
				{
					rgbTxtChooser->Activate(true);
					break;
				}
				BPoint p;
				uint32 buttons;
				parent->GetMouse(&p,&buttons);
				parent->ConvertToScreen(&p);
				p.x-=30;
				p.y-=30;
				float w=350,h=115;
				rgbTxtChooser = new ColorWindow(BRect(p.x,p.y,p.x+w,p.y+h),new BMessenger(this),prefs->RGBText_color);
				rgbTxtChooser->Show();
			}
		}break;
		case COLOURPREFS_UPDATE:
		{
			rgb_color*	Rgb;
			ssize_t		Size;
			rgb_color color;
			// if there is RGB color
			if((msg->FindData("color", B_RGB_COLOR_TYPE, (const void **)&Rgb, &Size) == B_OK))
			{
				prefs->RGBText_color = *Rgb;
				BString text;
				text << "\\textcolor[rgb]{" << (int)prefs->RGBText_color.red << "," << (int)prefs->RGBText_color.green << "," << (int)prefs->RGBText_color.blue << "}{}"; 
				InsertText(text.String());
			}
		}break;
		case COLOR_WINDOW_QUIT:
		{
			rgbTxtChooser = NULL;	
		
		}break;
		case MENU_FORMAT_SHIFT_RIGHT:
		{
			TexView* tv = CurrentTexView();
			if(tv != NULL)
			{
				tv->ShiftRight();
				
			}
		
		}break;
		case MENU_FORMAT_SHIFT_LEFT:
		{
			TexView* tv = CurrentTexView();
			if(tv != NULL)
			{
				tv->ShiftLeft();
				
			}
		
		}break;
		case B_NODE_MONITOR:
		{
			ResetPermissions();
			
		}break;
		case PREFS_TOOLBAR_INVALIDATE:
		{
			toolbar->RefreshColours();
		}break;

		case MENU_FORMAT_BOLD:
		{
			InsertText("\\textbf{}");
		}break;
		case MENU_FORMAT_EMPH:
		{
			InsertText("\\emph{}");
		}break;
		case MENU_FORMAT_ITAL:
		{
			InsertText("\\textit{}");
		}break;
		
		case CMD_DELETE_TEMP_FILES:
		{
			TListItem* item = CurrentTListItem();
			if(item != NULL)
			{
				entry_ref ref = item->GetRef();
				BPath path(&ref);
				if(path.InitCheck() == B_OK)
				{
					BPath parent;
					path.GetParent(&parent);
					const char* extensions[] = {".log"};
					int num_ext=1;
					BString basename(path.Leaf());
					basename.Replace(".tex","",1);
					for(int i=0;i<num_ext;i++)
					{
						BString del_me;
						del_me << parent.Path() << "/" << basename.String() << extensions[i];
						BEntry entry(del_me.String());
						if(entry.InitCheck() == B_OK)
						{
							entry.Remove();
						}
					}
				}
			}
			
		
		}break;
		case CMD_VIEW_LOG_FILE:
		{
			TListItem* item = CurrentTListItem();
			if(item != NULL)
			{
				entry_ref ref = item->GetRef();
				BPath path(&ref);
				if(path.InitCheck() == B_OK)
				{
					BString logpath;
					logpath << path.Path();
					logpath.Replace(".tex",".log",1);
					
					char* arg = (char*)logpath.String();
					be_roster->Launch("application/x-vnd.Be-STEE",1,&arg);
				}
			}
		
		}break;
		case UPDATE_CLIPBOARD_MENU_STATUS:
		{
			ResetPermissions();
		
		}break;
		case MENU_FILE_PAGE_SETUP:
		{
			TListItem* it = CurrentTListItem();
			if(it != NULL)
				PageSetup(it->FName());
		}break;
		case MENU_FILE_PRINT:
		{
			Print();
		}break;
		case MENU_FORMAT_COMMENTLINE:
		{
			//still one line too many commented/uncommented if newline is included at end of selection
			int32 start,finish;
			TexView* tv = CurrentTexView();
			if(tv != NULL)
			{
				tv->GetSelection(&start,&finish);
				if(start != finish)
				{
					vector<int> sols;
					vector<int> eols;
					tv->FillSolEol(sols,eols,start,finish);
					//int32 startline=-1;
					//int32 endline=-1;

					/*for(int i=0;i<sols.size();i++)
					{
						if(start >= sols[i] && start <= eols[i])
							startline = i;
						if(finish >= sols[i] && finish <= eols[i])
							endline = i;
						if(startline >= 0 && endline >= 0)
							break;
					}*/
					int offset=0;
					for(int i=0;i<sols.size();i++)
					{	
						tv->Insert(sols[i]+offset,"%",1);
						offset++;	//we have to do this because with each insert the sols[i] offset is invalid (a shift occurs)
					}
				}
			}
		
		}break;
		case MENU_FORMAT_UNCOMMENTLINE:
		{
			int32 start,finish;
			TexView* tv = CurrentTexView();
			if(tv != NULL)
			{
				tv->GetSelection(&start,&finish);
				if(start != finish)
				{
					vector<int> sols;
					vector<int> eols;
					tv->FillSolEol(sols,eols,start,finish);
					//int32 startline=-1;
					//int32 endline=-1;
					
					/*for(int i=0;i<sols.size();i++)
					{
						if(start >= sols[i] && start <= eols[i])
							startline = i;
						if(finish >= sols[i] && finish < eols[i])
							endline = i;
						if(startline >= 0 && endline >= 0)
							break;
					}*/
					//if(startline < 0 || endline < 0)
					//	break;
					BFont font(be_fixed_font);
					font.SetSize(12);
					int offset=0;
					for(int i=0;i<sols.size();i++)
					{
						const char* text = tv->Text();
						if(text[sols[i]-offset] == '%')	//we don't want to delete a non-comment
						{
							tv->Delete(sols[i]-offset,sols[i]-offset+1);
							offset++;//we have to do this because with each delete the sols[i] offset is invalid (a shift occurs)
						}
					}
					
						
				}
			}
		
		}break;
		
		case FILE_CONTENTS_CHANGED:
		{
			TListItem* item = CurrentTListItem();
			if(item != NULL)
			{
				if(!item->IsSaveNeeded())
				{
					item->SetSaveNeeded(true);
					listview->InvalidateItem(listview->CurrentSelection());
				}
			}
		
		}break;
		case SEARCH_WINDOW_FIND:
		{
			const char* ftext;
			int32	err;// = B_ERROR; 
			int32	endpoint;
			int32	length;
			
			if(msg->FindString("ftext",&ftext) == B_OK)
			{

/*
		bool IsCaseSensitive;
		bool IsWrapAround;
		bool IsSearchBackwards;
		bool IsAllDocs;
*/
					TexView* tv = CurrentTexView();
					if(tv != NULL)
					{
						
						BString findme;
						findme << ftext;
						length = findme.Length();
					
						if(length <= 0)
							return;
						
						BString text(tv->Text());
						
						int32 start,finish;
						tv->GetSelection(&start,&finish);
									
						if(prefs->IsSearchBackwards)
						{
							if(prefs->IsCaseSensitive)
							{
								err = text.FindLast(findme,start);
							}
							else
							{
								err = text.IFindLast(findme,start);
							}
						}
						else
						{
							if(prefs->IsCaseSensitive)
							{
								err = text.FindFirst(findme,finish);
							}
							else
							{
								err = text.IFindFirst(findme,finish);
							}
						}
						
						if(err < 0 && prefs->IsWrapAround)
						{
							if(prefs->IsSearchBackwards)
							{
								if(prefs->IsCaseSensitive)
								{
									err = text.FindLast(findme,text.Length());
								}
								else
								{
									err = text.IFindLast(findme,text.Length());
								}
							}
							else
							{
								if(prefs->IsCaseSensitive)
								{
									err = text.FindFirst(findme,0);
								}
								else
								{
									err = text.IFindFirst(findme,0);
								}
							}
						}
						if (err >= 0) 
						{
							finish = err + length;
							tv->Select(err, finish);
							tv->ScrollToSelection();
							Activate(true);
						}					
					}//end if(tv != NULL)
			}
		}break;
		case SEARCH_WINDOW_REPLACE:
		case SEARCH_WINDOW_REPLACE_ALL:
		{
			const char* ftext;
			const char* rtext;
			bool all;	
			if(msg->FindString("ftext",&ftext) == B_OK
			&& msg->FindString("rtext",&rtext) == B_OK			
			&& msg->FindBool("all",&all)==B_OK)
			{
				TexView* tv = CurrentTexView();
				if(tv != NULL)
				{
					BString findme;
					findme << ftext;
					
					BString replacewith;
					replacewith << rtext;
					
					BString text(tv->Text());
					
					
					int32 start,finish;
					int32 offset;
					if(all)
						start = 0;
					else
						tv->GetSelection(&start,&finish);
					//int32 lastoffset=-1;
					//if(replacewith.Length() > 0)
					//while((offset = text.FindFirst(findme.String(),start)) >= 0)
					//{
					//{	
					if(!all)
					{
						offset = text.FindFirst(findme,start);
						tv->Delete(offset,offset+findme.Length());
						tv->Insert(offset,replacewith.String(),replacewith.Length());
						tv->Select(offset,offset+replacewith.Length());
						tv->ScrollToSelection();
						Activate(true);
					}
					else
					{
						if(prefs->IsAllDocs)
						{
							TexView* tv;
							TListItem* item;
							//start = 0;
							for(int i=0;i<listview->CountItems();i++)
							{
								item = (TListItem*)listview->ItemAt(i);
								tv = (TexView*)item->TextView();
								if(item != NULL && tv != NULL)
								{
									text = tv->Text();
									if(prefs->IsCaseSensitive)
									{
										text.ReplaceAll(findme.String(),replacewith.String());
									}
									else
									{
										text.IReplaceAll(findme.String(),replacewith.String());
									}
									
									if(text.Compare(tv->Text()) == 0)
										return;	//the same after replace all
									
									tv->SetText(text.String(),text.Length());
									
									/*if(text.Length() < start)
										start = text.Length();
									if(text.Length() < finish)
										finish = text.Length();
									*/
									//if(i == listview->CountItems()-1)
									//{	
										//tv->Select(start,finish);
										//tv->ScrollToSelection();
										Activate(true);
									// }
								}
							}

						}
						else
						{
							
							if(prefs->IsCaseSensitive)
							{
								text.ReplaceAll(findme.String(),replacewith.String());
							}
							else
							{
								text.IReplaceAll(findme.String(),replacewith.String());
							}
							
							if(text.Compare(tv->Text()) == 0)
								return;	//the same after replace all
							
							tv->SetText(text.String(),text.Length());
							
							if(text.Length() < start)
								start = text.Length();
							if(text.Length() < finish)
								finish = text.Length();
								
							tv->Select(start,finish);
							tv->ScrollToSelection();
							Activate(true);
						
					
						}						
					
					}
				}
			}
		}break;
		case SEARCH_WINDOW_QUIT:
		{
			searchPanel = NULL;
		}break;
		case GTL_WINDOW_QUIT:
		gtlPanel = NULL;
		break;
		case ABOUT_WINDOW_QUIT:
		aboutPanel = NULL;
		break;
		
		case PREFS_WINDOW_QUIT:
		prefsPanel = NULL;
		break;
		
		case MENU_FILE_PREFS:
		{
			if(prefsPanel != NULL)
			{
				prefsPanel->Activate(true);
				break;
			}

			BPoint p;
			uint32 buttons;
			parent->GetMouse(&p,&buttons);
			parent->ConvertToScreen(&p);
			p.x-=30;
			p.y-=30;
			float w=600,h=400;
			prefsPanel = new PrefsWindow(BRect(p.x,p.y,p.x+w,p.y+h),new BMessenger(this),prefs);
			prefsPanel->Show();
		}break;
		case MENU_EDIT_SEARCH:
		{
			if(searchPanel != NULL)
			{
				searchPanel->Activate(true);
				break;
			}

			BPoint p;
			uint32 buttons;
			parent->GetMouse(&p,&buttons);
			parent->ConvertToScreen(&p);
			p.x-=30;
			p.y-=30;
			float w=380,h=235;
			searchPanel = new SearchWindow(BRect(p.x,p.y,p.x+w,p.y+h),new BMessenger(this),prefs);
			searchPanel->Show();
		}break;
		case MENU_EDIT_GOTOLINE:
		{
			if(gtlPanel != NULL)
			{
				gtlPanel->Activate(true);
				break;
			}
			BPoint p;
			uint32 buttons;
			parent->GetMouse(&p,&buttons);
			parent->ConvertToScreen(&p);
			p.x-=15;
			p.y-=15;
			gtlPanel = new GoToLineWindow(BRect(p.x,p.y,p.x+102,p.y+40),new BMessenger(this));
			gtlPanel->Show();
		}break;
			
		case ABOUT_WINDOW_LAUNCH:
		{
			if(aboutPanel != NULL)
			{
				aboutPanel->Activate(true);
				break;
			}
			BPoint p;
			uint32 buttons;
			parent->GetMouse(&p,&buttons);
			parent->ConvertToScreen(&p);
			p.x-=15;
			p.y-=15;
			aboutPanel = new AboutWindow(BRect(p.x,p.y,p.x+400,p.y+300),new BMessenger(this));
			aboutPanel->Show();
		}break;
		case GTL_WINDOW_GO:
		{
			int32 line;
			if(msg->FindInt32("line",&line)==B_OK)
			{
				TexView* tv = CurrentTexView();
				if(tv != NULL)
				{
					tv->GoToLine(line);
					tv->ScrollToSelection();
					UpdateStatusBar();
				}
			}
		
		}break;
		case MENU_EDIT_UNDO:
		{
			int current = listview->CurrentSelection();
			if(current >= 0)
			{
				TexView* tv;
				TListItem* item;
				item = (TListItem*)listview->ItemAt(current);
				tv = (TexView*)item->TextView();
//				tv->Undo();
			}
		}break;
		case MENU_EDIT_REDO:
		{
			int current = listview->CurrentSelection();
			if(current >= 0)
			{
				TexView* tv;
				TListItem* item;
				item = (TListItem*)listview->ItemAt(current);
				tv = (TexView*)item->TextView();
//				tv->Redo();
			}
		}break;
		case UPDATE_STATUSBAR:
		{
			ResetPermissions();
			UpdateStatusBar();
		}break;
		case CMD_TBUTTON_INSERT:
		{
			const char* cmd;
			if(msg->FindString("cmd",&cmd) == B_OK)
				InsertText(cmd);
		}break;
		case UPDATE_TEXTVIEW_SHORTCUTS:
		{
			SetShortcuts();
		}break;
		case CMD_LAUNCH_TERMINAL:
		{
			TListItem* item = CurrentTListItem();
			if(item != NULL)
			{
				BString cmd;
				//char* script = "/tmp/cdtodir.sh";
				entry_ref ref = item->GetRef();
				BPath path(&ref);
				if(path.InitCheck() == B_OK)
				{
					BPath parent;
					path.GetParent(&parent);
					cmd << "cd " << parent.Path() << " && /boot/beos/apps/Terminal &";
					system(cmd.String());
				}
			}
		}break;
		
		case CMD_LAUNCH_TRACKER:
		{
			TListItem* item = CurrentTListItem();
			if(item != NULL)
			{
				entry_ref ref = item->GetRef();
				BPath path(&ref);
				if(path.InitCheck() == B_OK)
				{
					BPath parent;
					path.GetParent(&parent);
					char* arg = (char*)parent.Path();
					be_roster->Launch("application/x-vnd.Be-TRAK",1,&arg);
				}
			}
		
		
		
		
		}break;
		
		case CMD_LAUNCH_DVIVIEWER:
		break;
		case CMD_LAUNCH_PSVIEWER:
		{
			Execute("/tmp/psview.sh",prefs->postscript_cmd.String());	
		}break;
		case CMD_LAUNCH_HTMLVIEWER:
		{
			TListItem* item = CurrentTListItem();
			if(item != NULL)
			{
				//char* script = "/tmp/cdtodir.sh";
				entry_ref ref = item->GetRef();
				BPath path(&ref);
				if(path.InitCheck() == B_OK)
				{
					BPath parent;
					path.GetParent(&parent);
					BString fname(path.Leaf());
					fname.Replace(".tex","",1);
					
					BString url;
					url << parent.Path() << "/" << fname.String() << "/" << fname.String() << ".html";
					char *args[] = {(char*)url.String(), NULL};
					be_roster->Launch("text/html",1,args);
					//application/x-vnd.Be-NPOS
				}
			}
		}break;
		case CMD_LAUNCH_BE_PDF:
		{
			if(listview->CountItems() >= 1)
			{
				int current = listview->CurrentSelection();
				if(current >= 0)
				{
					TListItem* li = (TListItem*)listview->ItemAt(current);
					entry_ref ref = li->GetRef();
					BPath path(&ref);
					if(path.InitCheck() == B_OK)
					{
						BPath parent;
						path.GetParent(&parent);
						
						BString pdfname(path.Leaf());
						pdfname.Replace(".tex",".pdf",1);
						parent.Append(pdfname.String());
						char *args[] = {(char*)parent.Path(), NULL};
						be_roster->Launch("application/x-vnd.mp-xpdf",1,args);
					}
				}
			}
		}break;
		case CMD_COMPILE_TEXDVI:
		{
			Execute("/tmp/textodvi.sh",prefs->latex_cmd.String());
		
		}break;
		case CMD_COMPILE_DVIPDF:
		{
			Execute("/tmp/dvitopdf.sh",prefs->dvipdf_cmd.String());
		
		}break;
		case CMD_COMPILE_DVIPS:
		{
			Execute("/tmp/dvitops.sh",prefs->dvips_cmd.String());
		
		}break;
		case CMD_COMPILE_PSPDF:
		{
			Execute("/tmp/pstopdf.sh",prefs->ps2pdf_cmd.String());
		
		}break;
		case CMD_COMPILE_TEXPDF:
		{
			Execute("/tmp/textopdf.sh",prefs->pdflatex_cmd.String());
		
		}break;
		case CMD_COMPILE_TEXHTML:
		{
			Execute("/tmp/textohtml.sh",prefs->latex2html_cmd.String());	
		}break;
		case B_SIMPLE_DATA:
		case MENU_FILE_OPEN_RECENT:
		case B_REFS_RECEIVED:
		{
			entry_ref ref;
			status_t err;
			int32 ref_num;
			ref_num = 0;
			while((err = msg->FindRef("refs", ref_num, &ref)) == B_OK)
			{
				BNode node(&ref);
				if(node.InitCheck()==B_OK)
				{
					BNodeInfo ni(&node);
					if(ni.InitCheck() == B_OK)
					{
						
						char mime[B_MIME_TYPE_LENGTH];
						if(ni.GetType(mime)==B_OK)
						{
							BString str(ref.name);
							
							if(str.FindFirst(".tex") > 0 && (strcmp(TEX_FILETYPE,mime) == 0 || strcmp("text/plain",mime) == 0))
							{
									
								listview->AddItem(new TListItem(SP,docScroll,&ref,prefs));
								be_roster->AddToRecentDocuments(&ref,APP_SIG);			
								listview->Select(listview->CountItems()-1);							
							}
						}
						if(strcmp(mime,"application/x-vnd.Be-directory")==0 ||
							strcmp(mime,"application/x-vnd.Be-symlink")==0)
							{
								entry_ref  dir_contains_ref;
								BMessage process_dir(B_SIMPLE_DATA);
								BDirectory dir(&ref);
								if(dir.InitCheck() == B_OK)
								{
									while(dir.GetNextRef(&dir_contains_ref) == B_OK)
									{	
										if(process_dir.AddRef("refs",&dir_contains_ref) != B_OK)
											return;
										
									}	
									PostMessage(&process_dir,this);
								}
							}
						
					}
				}
				ref_num++;
				
			}
		//	OkToRemoveItem = true;
			if(prefs->IsActivationOk && !IsActive())
				Activate();
		}break;
		case MENU_FILE_OPEN_TEMPLATE:
		{
			entry_ref ref;
			status_t err;
			if(msg->FindRef("refs",&ref) == B_OK)
			{
				BNode node(&ref);
				if(node.InitCheck()==B_OK)
				{
					BNodeInfo ni(&node);
					if(ni.InitCheck() == B_OK)
					{
						
						char mime[B_MIME_TYPE_LENGTH];
						if(ni.GetType(mime)==B_OK)
						{
							BString str(ref.name);
							if(str.FindFirst(".tex") > 0 && (strcmp(TEX_FILETYPE,mime) == 0 || strcmp("text/plain",mime) == 0))
							{
								/*listview->AddItem(new TListItem(SP,docScroll,&ref,prefs));
								be_roster->AddToRecentDocuments(&ref,"application/x-vnd.misza-BeTeX");			
								listview->Select(listview->CountItems()-1);		
								*/
								//BString fname(ref.name);
								listview->AddItem(new TListItem(SP,docScroll,&ref,prefs,true));	
								listview->Select(listview->CountItems()-1);
								/*TexView* tv = CurrentTexView();
								if(tv != NULL)
									tv->LoadFile(&ref);*/
								ResetPermissions();				
							}
						}
					}
				}
			}
		
		}break;
		case B_SAVE_REQUESTED:
		{
			 Save(msg,listview->CurrentSelection());
			
			if(RemoveAfterSave)
			{
				int32 current = RemoveAfterSaveIndex;
				listview->RemoveItem(current);
				int items = listview->CountItems();
				if(items == 0)
				{
					SetTitle("BeTeX");
					untitled_no = 1;
				}
				else
				{
					
					if(current - 1 >= 0)
						listview->Select(current-1);
					else if(current < items)
						listview->Select(current);
				}							
				
				UpdateStatusBar();
				RemoveAfterSave = false;
			}
	
		}break;

		case MENU_FILE_NEW:
		{
			NewDocument();
			
		}
			break;
		case MENU_FILE_OPEN:
			openPanel->Show();
			break;
		case MENU_FILE_OPEN_FOLDER:
			openfolderPanel->Show();
			break;
		case MENU_FILE_CLOSE:
		{
			Close(listview->CurrentSelection());
			
		}	break;

		case MENU_FILE_SAVEAS:
		{
			 SaveAsPanel(listview->CurrentSelection());
		}
			break;
		case MENU_FILE_SAVE:
		{
			 Save(NULL,listview->CurrentSelection());
		}
			break;
		case MENU_FILE_NEXT_ITEM:
			listview->Next(1);
		break;
		case MENU_FILE_PREV_ITEM:
			listview->Prev(1);
			break;

		case MENU_FILE_QUIT:
		{
			//cout << "test" << endl;
			QuitRequested();
		}break;
		case MENU_FILE_ABOUT:
			be_app->PostMessage(B_ABOUT_REQUESTED);
			break;
		case RESET_ALL_TEX_VIEW_COLORS:
		{
			TexView* tv;
			TListItem* item;
			for(int i=0;i<listview->CountItems();i++)
			{
				item = (TListItem*)listview->ItemAt(i);
				tv = (TexView*)item->TextView();
				if(item != NULL && tv != NULL)
				{
					tv->UpdateColors();
					tv->SetViewColor(prefs->bg_color);
					tv->Invalidate();				
				}
			}
										
		}break;
		case RESET_ALL_TEX_VIEW_FONTS:
		{
			TexView* tv;
			TListItem* item;
			for(int i=0;i<listview->CountItems();i++)
			{
				item = (TListItem*)listview->ItemAt(i);
				tv = (TexView*)item->TextView();
				if(item != NULL && tv != NULL)
				{
					tv->UpdateFontSize();				
				}
			}
		}break;
		default:
			BWindow::MessageReceived(msg);
	    break;
	}
}
void TWindow::NewDocument()
{
		
		BString fname;
		fname << "Untitled" << untitled_no << ".tex";
		listview->AddItem(new TListItem(SP,docScroll,fname,prefs));
		untitled_no++;
		listview->Select(listview->CountItems()-1);
		ResetPermissions();
}

void TWindow::SetShortcuts()
{
	int current = listview->CurrentSelection();
	if(current >= 0)
	{
		TListItem* li = (TListItem*)listview->ItemAt(current);
		fcut->SetTarget(li->TextView());
		fcopy->SetTarget(li->TextView());
		fpaste->SetTarget(li->TextView());
		fselall->SetTarget(li->TextView());
		fundo->SetTarget(li->TextView());
	}
}
void TWindow::Close(int32 current)
{
		if(current >=0)
		{
			TListItem* li = (TListItem*)listview->ItemAt(current);
			if(li != NULL && li->IsSaveNeeded())
			{
				BString text;
				text << "Save changes to \"" << li->FName() << "\"?";
				
				BAlert* alert = new BAlert("savealert",text.String(),"Cancel", "Don't Save","Save",
				B_WIDTH_AS_USUAL,B_WARNING_ALERT);
				alert->SetShortcut(0,B_ESCAPE);
				int32 button_index = alert->Go();
				switch(button_index)
				{
					case 0:
						break;
					//break;
					case 1:
					{
						
						//listview->Invalidate();
						
						//if(!all)
						//{
							listview->RemoveItem(current);
							int items = listview->CountItems();
							if(items == 0)
							{
								SetTitle("BeTeX");
								untitled_no = 1;
							}
							else
							{
								
								if(current - 1 >= 0)
									listview->Select(current-1);
								else if(current < items)
									listview->Select(current);
							}							
							
							
						//}
					}break;
					case 2:
					{	
						 //OkToRemoveItem = false;
						 RemoveAfterSave = true;
						 RemoveAfterSaveIndex = current;
						 Save(NULL,current);
						 //for(;!OkToRemoveItem;)
						 //	;
						// while(savePanel->IsShowing())
						// 	cout << "crap" << endl;	
						//listview->Invalidate();
					}break;
				}	//end switch
				if(!cbfq.empty())
				{
					if(cbfqindex+1 != cbfq.size())
					{
						cbfqindex++;			
						Close(cbfq[cbfqindex]);
					}
					else
					{
						cbfqindex = 0;
						cbfq.clear();
					}
				}

		}	//end save needed
		else //if(!all)
		{
				listview->RemoveItem(current);
				//listview->Invalidate();
				
				int items = listview->CountItems();
				if(items == 0)
				{
					SetTitle("BeTeX");
					untitled_no = 1;
				}
				else
				{
					
					if(current - 1 >= 0)
						listview->Select(current-1);
					else if(current < items)
						listview->Select(current);
				}			
				
		}
	}	
		//end if(current >=0) 
			//if(!all)	//if we only want to close one item we break here
			//	break;
		//}	//end for
		//end if numitems > 0
		//else	I like this but hey :=)
		//	be_app->PostMessage(B_QUIT_REQUESTED);
		UpdateStatusBar();
		ResetPermissions();
}
void TWindow::Save(BMessage* msg,int32 index)
{
	
			entry_ref ref;
			const char* fname;
			BPath path;
			BEntry entry;

			//int current = listview->CurrentSelection();
			if(index >=0)
			{
				TListItem* li = (TListItem*)listview->ItemAt(index);
				//if(msg)
				
				if (msg && (msg->FindRef("directory", &ref)) == B_OK && (msg->FindString("name", &fname)) == B_OK)
				{
					if(entry.SetTo(&ref) == B_OK)
					{
						entry.GetPath(&path);
						BString name_checker=fname;
						if(name_checker.FindFirst(".tex") < 0)
						{	
							name_checker << ".tex";							
							fname = name_checker.String(); 
						}
						
						path.Append(fname);
						
						BFile file(path.Path(),B_READ_WRITE | B_CREATE_FILE | B_ERASE_FILE);
						if(file.InitCheck() == B_OK)
						{
							file.Write(li->TextView()->Text(),li->TextView()->TextLength());
							file.Unset();
							update_mime_info(path.Path(),0,0,0);
							
							BString title;
							title << "BeTeX" << " - " << fname;
							SetTitle(title.String());
							
							BEntry final_entry(path.Path());
							entry_ref final_ref;
							final_entry.GetRef(&final_ref);
							li->SetRef(&final_ref);
							//li->Select();
							li->SetHomely(true);
							li->SetSaveNeeded(false);
							listview->InvalidateItem(index);
							
						}
					}
				}	
				else	//Save to current file
				{
					if(li->IsHomely()) //we can save somewhere
					{	
						ref = li->GetRef();
						BFile file(&ref,B_READ_WRITE | B_ERASE_FILE);
						if(file.InitCheck() == B_OK)
						{
							file.Write(li->TextView()->Text(),li->TextView()->TextLength());
							li->SetSaveNeeded(false);
							li->SetHomely(true);
							listview->InvalidateItem(index);
							
						}
					}
					else	//need to choose initial name
					{
						 SaveAsPanel(index);
						 
					}
					
				}
			}
			ResetPermissions();
			UpdateStatusBar();
}
void TWindow::MenusBeginning()
{
	for(int i=opensubmenu->CountItems()-1;i>=0;i--)
	{
		delete opensubmenu->RemoveItem(i);
	}
	
	BMessage recentrefs;
	be_roster->GetRecentDocuments(&recentrefs,atoi(prefs->NumRecentDocs.String()),TEX_FILETYPE,APP_SIG);
		
	entry_ref ref;
	status_t err;
	int32 ref_num;
	ref_num = 0;
	while(recentrefs.FindRef("refs", ref_num,&ref) == B_OK)
	{
		BMessage* openmsg = new BMessage(MENU_FILE_OPEN_RECENT);
		BEntry entry(&ref);
		if(entry.InitCheck() == B_OK && entry.Exists() && openmsg->AddRef("refs",&ref) == B_OK)
		{
			BPath temp_path(&ref);
			const char* label = prefs->IsRecentDocsPathShown ? temp_path.Path() : temp_path.Leaf() ;
			opensubmenu->AddItem(new BMenuItem(label,openmsg));		
		}
		
		ref_num++;
	}
	
	for(int j=fopentemplatesubmenu->CountItems()-1;j>=0;j--)
	{
		delete fopentemplatesubmenu->RemoveItem(j);
	}
	
	if(TemplateDir.Length() > 0)
	{
		BEntry entryTemplate(TemplateDir.String());
		if(!entryTemplate.InitCheck() || !entryTemplate.Exists())
		{
			if(create_directory(TemplateDir.String(),0777)!= B_OK)
			{
				return;
			}
		}
		BDirectory dir(TemplateDir.String());
		if(dir.InitCheck() == B_OK)
		{
			while(dir.GetNextRef(&ref) == B_OK)
			{
				BMessage* openmsg = new BMessage(MENU_FILE_OPEN_TEMPLATE);
				BEntry entry(&ref);
				if(entry.InitCheck() == B_OK && entry.Exists() && openmsg->AddRef("refs",&ref) == B_OK)
				{
					BNode node(&ref);
					if(node.InitCheck()==B_OK)
					{
						BNodeInfo ni(&node);
						if(ni.InitCheck() == B_OK)
						{
							char mime[B_MIME_TYPE_LENGTH];
							if(ni.GetType(mime)==B_OK)
							{
								BString str(ref.name);
								if(str.FindFirst(".tex") > 0 && (strcmp(TEX_FILETYPE,mime) == 0 || strcmp("text/plain",mime) == 0))
								{
									fopentemplatesubmenu->AddItem(new BMenuItem(ref.name,openmsg));		
								}
							}
						}
					}
				}
				
			}
		
		
		}	
	}
}
