#ifndef _TWINDOW_H_
#define _TWINDOW_H_

//Basics
#include <Window.h>
#include <Application.h>
#include <View.h>

#include <Clipboard.h>
#include <Mime.h>
#include <Alert.h>
//Menubar
#include <MenuBar.h>
#include <Menu.h>
#include <MenuItem.h>

#include <unistd.h>
#include <stdlib.h>

#include <string.h>
#include <stdio.h>
//TabView
//#include <TabView.h>

//TexView
//#include "TexView.h"
#include <ScrollView.h>
#include <ScrollBar.h>
//OpenPanel
#include <Entry.h>
#include <FilePanel.h>
#include <Path.h>
#include <File.h>
#include <Node.h>
#include <NodeInfo.h>
#include <Directory.h>
#include "TexFileFilter.h"
//SavePanel

//Miscellaneous
#include <String.h>
#include "Constants.h"
#include <stdio.h>
#include <stdlib.h>
#include <iostream>
#include <PrintJob.h>
//Toolbar
#include "MainTBar.h"
#include <Roster.h>

#include "TexBar.h"
#include "DocView.h"
//SplitPaneView
#include "SplitPane.h"
//ListView
#include "TListView.h"
#include "TListItem.h"

#include "SearchWindow.h"
#include "GoToLineWindow.h"
#include "AboutWindow.h"
#include <vector>
#include "misza_status_view.h"
#include "PrefsWindow.h"
#include <MessageRunner.h>
#include "Prefs.h"
#include "DimensionWindow.h"
//#include "SpanishWindow.h"
//#include <OS.h> //threads
#include "BubbleHelper.h"

class TWindow : public BWindow
{
	public:
		TWindow(BRect r/*,bool b,string d*/,Prefs* p);
		~TWindow();
		virtual bool QuitRequested();
		virtual void MessageReceived(BMessage* msg);
//		virtual void FrameResized(float w,float h);
		void Save(BMessage* msg,int32 index);
		void SaveAsPanel(int32 index);
		void Close(int32 current);
		void NewDocument();
		void SetShortcuts();
		void InsertText(const char* text);
		virtual void MenusBeginning();
		void UpdateStatusBar();
		TexView* CurrentTexView();
		TListItem* CurrentTListItem();
		bool PromptToQuit();
		void Execute(char* script,const char* cmd);
		void Print();
		status_t PageSetup(const char* fname);
		void ResetPermissions();
		//void CheckFilesPresent();
		//void InsertButtonText(const char* text);
		//void Search();
		//void Replace(bool all);
		//void Open(entry_ref* ref);
	private:
		BString TemplateDir;
		//bool OkToRemoveItem;
		TexBar* toolbar;
		BPath parent_dir;
		BPath TexPath;
		BString basename;
		vector<BPath> watchedPaths;
		Prefs* prefs;
		
		bool RemoveAfterSave;
		bool RemoveAfterSaveIndex;
		
		vector<int> cbfq;
		int32 cbfqindex;
		BView* parent;
		//OpenPanel
		BFilePanel* openPanel;
		//SavePanel
		BFilePanel* savePanel;
		//Menus for Menubar
		
		BFilePanel* openfolderPanel;
		PrefsWindow* prefsPanel;
		SearchWindow* searchPanel;
		GoToLineWindow* gtlPanel;
		AboutWindow* aboutPanel;
		ColorWindow* rgbTxtChooser;
		DimensionWindow* dimChooser;
		BFilePanel* insertfilePanel;
		BMenuBar* menubar;
			BMenu* filemenu;
				BMenuItem* fnew;
				BMenuItem* fopen;
					BMenu* opensubmenu;
				BMenuItem* fopenfolder;
					
				BMenuItem* fopentemplate;
					BMenu* fopentemplatesubmenu;
					
				BMenuItem* fclose;
				BMenuItem* fsave;
				BMenuItem* fsaveas;
				//_________________
				BMenuItem* fnextitem;
				BMenuItem* fprevitem;
				//_________________
				BMenuItem* fpgsetup;
				BMenuItem* fprint;
				//_________________
				BMenuItem* fprefs;
				BMenuItem* freset_layout;
				BMenuItem* fabout;
				BMenuItem* fquit;
		
			BMenu* editmenu;
				BMenuItem* fundo;
				BMenuItem* fredo;
				//_________________
				BMenuItem* fcut;
				BMenuItem* fcopy;
				BMenuItem* fpaste;
				//_________________
				BMenuItem* fselall;
				//_________________
				BMenuItem* fsearchreplace;
				BMenuItem* fgotoline;
			BMenu* formatmenu;
				BMenuItem* fbold;
				BMenuItem* femph;
				BMenuItem* fital;
				//_________________
				BMenuItem* fshiftleft;
				BMenuItem* fshiftright;
				//_________________
				BMenuItem* fcomment;
				BMenuItem* funcomment;
			BMenu* insertmenu;
				BMenuItem* finsertfile;
				BMenuItem* fdate;
				BMenuItem* farray;
				BMenuItem* fmatrix;
				BMenuItem* ftabular;
				BMenuItem* fequation;
				BMenuItem* frgbcolor;
				BMenuItem* flists;
					BMenu* flistsubmenu;
						BMenuItem* fitemize;
						BMenuItem* fdescription;
						BMenuItem* fenumerate;
						BMenuItem* fcases;
					
				BMenuItem* fenvironments;     
					BMenu* fenvironmentssubmenu;			
						BMenuItem* ffigure;
						BMenuItem* ftable;
						BMenuItem* fetabular;
						BMenuItem* fetabularstar;
						BMenuItem* ftabbing;
						BMenuItem* fcenter;
						BMenuItem* fflushleft;
						BMenuItem* fflushright;
						BMenuItem* feqnarray;
						BMenuItem* ffeqnarraystar;
						BMenuItem* fverbatim;
						BMenuItem* fquote;
						BMenuItem* fminipage;
					
				
			BMenu* compilemenu;
				BMenuItem* ftexdvi;
				BMenuItem* fdvipdf;
				BMenuItem* fdvips;
				BMenuItem* fpspdf;
				BMenuItem* ftexpdf;
				BMenuItem* ftexhtml;
			BMenu* previewmenu;
				BMenuItem* fpostscript;
				BMenuItem* fpdf;
				BMenuItem* fhtml;
			
			BubbleHelper* helper;	
			BScrollView* scrollView;
			SplitPane* SP;
			SplitPane* LEFT;
			TListView* listview;
			BScrollView* docScroll;
			//BAlert* close_alert;
			//BTabView Stuff
/*			BTabView* tabView;
			BTab* tab;
			int TabIndex;
			int TabNumber;
			
			TexView* tv;
*/
			//Document management
			int untitled_no;
			
			int TLIST_VIEW_WIDTH;
			float LEFT_BAR_V_POS;
			
			
			//Main ToolBar
			MainTBar* mtbar;
			
			zStatusView* StatusBar;
			BMessage* printer_settings;
			
		//	static int32 Open(void * arg);
		//	thread_id open_thread;
			
};
#endif

